---------------------------------------------------------------------------------------------------------------------------------
DTweaks = LibStub("AceAddon-3.0"):NewAddon("DTweaks", "AceConsole-3.0","AceEvent-3.0")
local addon = LibStub("AceAddon-3.0"):GetAddon("DTweaks")
local AceConfigRegistry = LibStub("AceConfigRegistry-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local addonName, addonTable = ...
addon.optionsFrame = {}
local options = nil
local Version = GetAddOnMetadata("DTweaks", "Version")

local function eventHandler(self, event, ...)
      if ( event == "PLAYER_ENTERING_WORLD" ) then
         self:UnregisterEvent("PLAYER_ENTERING_WORLD")
         DEFAULT_CHAT_FRAME:AddMessage(string.format("|cFF00FF00DTweaks:|r [v|cFFDF2B2B"..Version.."|r] Loaded!|cFFFFCC00 Enjoy!!|r\n  -- Type |cFF00FFFF/dt|r for configuration options.\n  -- Type |cFF00FFFF/dtpf|r for player and target frame mover.\n  -- Type |cFF00FFFF/dtbags|r for bag mover/scaler options.\n  -- Type |cFF00FFFF/dt help|r for additional command line options."))
      end
     end
local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:SetScript("OnEvent", eventHandler)

---------------------------------------------------------------------------------------------------------------------------------
--[[ Init section ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:OnInitialize()
  -- Common Slash Cmds --
  self:RegisterChatCommand("dt", "dtSlashCommands")

  self.db = LibStub("AceDB-3.0"):New("DTweaksDB")
  self.db:RegisterDefaults({
    char = {
      Focus_CastBar_Mover         = false,
      Pet_Damage_Spam             = false,
      Player_Damage_Spam          = false,
      Quick_Loot                  = false,
      Reverse_Sort_Bags           = false,
      Target_CastBar_Mover        = false,
      C_JunkList                  = false,
      HideTalkingHead             = false,
      Buffs_16                    = false,
      DTweaks_Bag_Mover           = false,
      noauto_loot_hist            = false,
      -----------------------------------
      bagmover                    = {},
      junklist                    = {},
      Auto_Select_QuestReward     = true,
      AutoRepair                  = true,
      AutoRepSwitch               = true,
      AutoTypeDelete              = true,
      CastBar_Timer               = true,
      Chat                        = true,
      Durability_ItemLevel_Chants = true,
      Enlarge_Player_Target_Frame = true,
      Fonts                       = true,
      JunkSeller                  = true,
      MapCords                    = true,
      Micro_Button_Tips           = true,
      MiniMap                     = true,
      Player_Target_Mover         = true,
      QuestLevel                  = true,
      Remove_Griffins             = true,
      ScreenGrid                  = true,
      Slash                       = true,
      TinyMainbarInfo             = true,
      ToTtip                      = true,
      ToTtip                      = true,
      UnDress                     = true,
      Zoomed                      = true,
    },

    global = {
      junklist = {},
    }
  })

  ---------------------------
  self:PopulateOptions()
  AceConfigRegistry:RegisterOptionsTable("DTweaks", options)
  addon.optionsFrame = AceConfigDialog:AddToBlizOptions("DTweaks", nil, nil, "general")
  ---------------------------
  
  ---------------------------
  if addon.db.char.Remove_Griffins then addon:hide_griffins() end
  ---------------------------
  
  ---------------------------
  -- DT Buffs_16 Default Blizz interface top right
  ---------------------------
  if addon.db.char.Buffs_16 then BUFFS_PER_ROW = 16 else BUFFS_PER_ROW = 8 end

  ---------------------------
  
  if addon.db.char.AutoTypeDelete then
     -- add delete string to delete option so you only have to click ok on the confirmation popuup
     hooksecurefunc(StaticPopupDialogs["DELETE_GOOD_ITEM"],"OnShow",function(s) s.editBox:SetText(DELETE_ITEM_CONFIRM_STRING) end)
  end
  ---------------------------

  ---------------------------
  function addon:OnEnable() self:RegisterEvent("MERCHANT_SHOW") end

  function addon:MERCHANT_SHOW()
   if addon.db.char.JunkSeller then addon:JunkSeller() end
   if addon.db.char.AutoRepair then addon:AutoRepair() end
  end
  ---------------------------

  ---------------------------
  -- Common slash commands
  ---------------------------
  if addon.db.char.Slash then
  ---------------------------[[ /rl for reload ui ]]--
     SlashCmdList["RL"] = function() ReloadUI() end
     SLASH_RL1 = '/rl'
  ---------------------------[[ /rc for readycheck ]]--
     SlashCmdList["READYCHECK"] = function() DoReadyCheck() end
     SLASH_READYCHECK1 = '/rc'
  ---------------------------[[ /cr for check role  ]]--
     SlashCmdList["CHECKROLE"] = function() InitiateRolePoll() end
     SLASH_CHECKROLE1 = '/cr'
  ---------------------------[[ /rh for Hide default Raid windows ]]--
     SlashCmdList["RAIDHIDE"] = function() CompactRaidFrameManager:Hide() end
     SLASH_RAIDHIDE1 = '/rh'
  ---------------------------[[ /rs for Show default Raid windows ]]--
     SlashCmdList["RAIDSHOW"] = function() CompactRaidFrameManager:Show() end
     SLASH_RAIDSHOW1 = '/rs'
  ---------------------------[[ /rm for Random Mount ]]--
     SlashCmdList["RANDOMMOUNT"] = function() C_MountJournal.SummonByID(0) end
     SLASH_RANDOMMOUNT1 = '/rm'
  ---------------------------[[ /lg for Leave Group ]]--
     SlashCmdList["LEAVEGROUP"] = function()
     SendChatMessage("Thanks for the Group","SAY")
     LeaveParty() end
     SLASH_LEAVEGROUP1 = '/lg'
  ---------------------------[[ /tout to Teleport Out of LFG/LFR ]]--
     SlashCmdList["TOUT"] = function() LFGTeleport(true) end
     SLASH_TOUT1 = '/tout'
  ---------------------------[[ /tin to Teleport to LFG/LFR ]]--
     SlashCmdList["TIN"] = function() LFGTeleport() end
     SLASH_TIN1 = '/tin'
  end
  ---------------------------
  
  ---------------------------
  -- DT Chat Mods
  ---------------------------
  if addon.db.char.Chat then addon:DTChat() end
  ---------------------------

  ---------------------------
  -- DT Zoomed set max camera
  ---------------------------
  if addon.db.char.Zoomed then
     C_Timer.After(1, function() SetCVar("cameraDistanceMaxZoomFactor","2.6") end)
  else
     C_Timer.After(1, function() SetCVar("cameraDistanceMaxZoomFactor","1.9") end)
  end

  ---------------------------
  -- DT MiniMap mods
  ---------------------------[[ Hide Mini-Map Zoom Buttons ]]--
  if addon.db.char.MiniMap then 
     MinimapZoomIn:Hide()
     MinimapZoomOut:Hide()
  ---------------------------[[ Enable Mini-Map Zoom Mouse Scrolling ]]--
     Minimap:EnableMouseWheel(true)
     Minimap:SetScript("OnMouseWheel", function(self, m_zoom) if m_zoom > 0 then _G.MinimapZoomIn:Click() else _G.MinimapZoomOut:Click() end end)
  end
  ---------------------------

  ---------------------------
  -- DT MapCords
  ---------------------------
  if addon.db.char.MapCords then addon:DTMapCords() end

  ---------------------------
  -- DT Micro_Button_Tips
  ---------------------------
  if addon.db.char.Micro_Button_Tips then addon:DTMicro_Button_Tips() end

  ---------------------------
  -- DT Auto_Select_QuestReward
  ---------------------------
  if addon.db.char.Auto_Select_QuestReward then addon:DTAuto_Select_QuestReward() end

  ---------------------------
  -- DT AutoRepSwitch
  ---------------------------
  if addon.db.char.AutoRepSwitch then addon:DTAutoRepSwitch() end

  ---------------------------
  -- DT CastBar_Timer
  ---------------------------
  if addon.db.char.CastBar_Timer then addon:DTCastBar_Timer() end

  ---------------------------
  -- DT Durability_ItemLevel_Chants
  ---------------------------
  if addon.db.char.Durability_ItemLevel_Chants then addon:DTDurability_ItemLevel_Chants() end

  ---------------------------
  -- DT Enlarge_Player_Target_Frame
  ---------------------------
  if addon.db.char.Enlarge_Player_Target_Frame then
     --[[ Increase Default Player/Target Unit Frame "1.1 = 110%, 1.2 = 120%, 1.3 =130% ..... " ]]--
     PlayerFrame:SetScale(1.2)
     TargetFrame:SetScale(1.2)
  end

  ---------------------------
  -- DT Focus_CastBar_Mover checked Top unchecked Bottom
  ---------------------------
  if addon.db.char.Focus_CastBar_Mover then
     -- Set the cast bar above the focus frame instead of under the auras: 
     FocusFrameSpellBar:ClearAllPoints()
     FocusFrameSpellBar:SetPoint("BOTTOM", FocusFrame, "TOP", -15, 0)
     FocusFrameSpellBar.SetPoint = function() end
  else
     -- Set the cast bar back to default on bottom
    FocusFrameSpellBar:ClearAllPoints()
    FocusFrameSpellBar:SetPoint("BOTTOM", FocusFrame, "Bottom", -15, 0)
    FocusFrameSpellBar.SetPoint = function() end
  end

  ---------------------------
  -- DT Target_CastBar_Mover checked Top unchecked Bottom
  ---------------------------
  if addon.db.char.Target_CastBar_Mover then
     -- Set the cast bar above the target frame
     TargetFrameSpellBar:ClearAllPoints()
     TargetFrameSpellBar:SetPoint("BOTTOM", TargetFrame, "TOP", -15, 0)
     TargetFrameSpellBar.SetPoint = function() end
  else
     -- Set the cast bar back to default on bottom
     TargetFrameSpellBar:ClearAllPoints()
     TargetFrameSpellBar:SetPoint("BOTTOM", TargetFrame, "Bottom", -15, 0)
     TargetFrameSpellBar.SetPoint = function() end
  end

  ---------------------------
  -- DT ToTtip
  ---------------------------
  if addon.db.char.ToTtip then addon:DTToTtip() end

  ---------------------------
  -- DT Fonts
  ---------------------------
  if addon.db.char.Fonts then
     --[[  Enables a nice default font for damage, unit frames, and standard text for your UI. ]]--
     UNIT_NAME_FONT     = "Interface\\AddOns\\DTweaks\\DTweaks.ttf"
     DAMAGE_TEXT_FONT   = "Interface\\AddOns\\DTweaks\\DTweaks.ttf"
     STANDARD_TEXT_FONT = "Interface\\AddOns\\DTweaks\\DTweaks.ttf"
  end

  ---------------------------
  -- DT Player_Damage_Spam
  ---------------------------
  if addon.db.char.Player_Damage_Spam then
     PlayerHitIndicator:SetText(nil)
     PlayerHitIndicator.SetText = function() end
  else
     PlayerHitIndicator:SetText(true)
     PlayerHitIndicator.SetText = function() end
  end

  ---------------------------
  -- DT Pet_Damage_Spam
  ---------------------------
  if addon.db.char.Pet_Damage_Spam then
     PetHitIndicator:SetText(nil)
     PetHitIndicator.SetText = function() end
  else
     PetHitIndicator:SetText(nil)
     PetHitIndicator.SetText = function() end
  end

  ---------------------------
  -- DT QuestLevel
  ---------------------------
  if addon.db.char.QuestLevel then addon:DTQuestLevel() end

  ---------------------------
  -- DT Quick_Loot
  ---------------------------
  if addon.db.char.Quick_Loot then addon:DTQuick_Loot() end

  ---------------------------
  -- DT TinyMainbarInfo
  ---------------------------
  if addon.db.char.TinyMainbarInfo then addon:DTTinyMainbarInfo() end

  ---------------------------
  -- DT UnDress
  ---------------------------
  if addon.db.char.UnDress then addon:DTUnDress() end

  ---------------------------
  -- DT ScreenGrid
  ---------------------------
  if addon.db.char.ScreenGrid then addon:DTScreenGrid() end

  ---------------------------
  -- DT Player_Target_Mover
  ---------------------------
  if addon.db.char.Player_Target_Mover then self:RegisterChatCommand("dtpf", "dtpfSlashCommands") end

  ---------------------------
  -- DT Reverse_Sort_Bags
  ---------------------------
  if addon.db.char.Reverse_Sort_Bags then SetSortBagsRightToLeft(true) else SetSortBagsRightToLeft(false) end

  ---------------------------
  -- DT Hide Blizzard Talking Head
  ---------------------------
  if addon.db.char.HideTalkingHead then addon:HideTalkingHead() end

  ---------------------------
  -- DT Hide Blizzard Talking Head
  ---------------------------
  if addon.db.char.DTweaks_Bag_Mover then addon:DT_Bag_Mover() end

  ---------------------------
  -- DT Turn off Auto Loot hist popup window
  -- /run print ( GetCVar("autoOpenLootHistory") ) -- to list in game
  ---------------------------
  if addon.db.char.noauto_loot_hist then
     C_Timer.After(1, function() SetCVar("autoOpenLootHistory", 0) end)
  else
     C_Timer.After(1, function() SetCVar("autoOpenLootHistory", 1) end)
  end

end

---------------------------------------------------------------------------------------------------------------------------------
--[[ END Init section ]]--
---------------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------
--[[  Hide blizzard talking headframe ]]--
----------------------------------------------------------------------
function addon:HideTalkingHead()
 -- Function to hide the talking frame
 local function NoTalkingHeads()
        hooksecurefunc(TalkingHeadFrame, "Show", function(self) self:Hide() end)
       end
  -- Run when blizzard addon is loaded
  if IsAddOnLoaded("Blizzard_TalkingHeadUI") then NoTalkingHeads()
  else
     local waitFrame = CreateFrame("FRAME")
           waitFrame:RegisterEvent("ADDON_LOADED")
           waitFrame:SetScript("OnEvent", function(self, event, arg1)
            if arg1 == "Blizzard_TalkingHeadUI" then
               NoTalkingHeads()
               waitFrame:UnregisterAllEvents()
            end
           end)
 end
end
----------------------------------------------------------------------
--[[  END Hide blizzard talking headframe ]]--
----------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks print link mythic key in bag ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:FindKey()
 local foundkey = false
 for bag=0,4 do
   for slot = 1,GetContainerNumSlots(bag) do
     local item = GetContainerItemLink(bag,slot)
     if item then
        local _, _, _, _, _, _, link, _, _, itemID = GetContainerItemInfo(bag,slot)
        if itemID == 138019 then
           foundkey = true
           key = link
        end
     end
   end
 end
 if foundkey then
    self:Print("Found Key"..": "..key)
 else
    self:Print("No Key Found"..": ")
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks print link mythic key in bag ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Slash Commands ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:dtSlashCommands(input)
 local var1, var2 = self:GetArgs(input, 2, 1, input)
 if var1 == 'help' then
    self:Print("\
Options for |cFF00FFFF/dt|r:\
|cFF00FFFF/dt|r to open configuration panel\
|cFF00FFFF/dt key|r to list mythic key in your bags\
|cFF00FFFF/dt npcid|r to list targeted npcid\
|cFF00FFFF/dt list|r to list items in junklist\
|cFF00FFFF/dt add <itemlink>|r to add item to junklist\
|cFF00FFFF/dt rem <itemlink>|r to remove item from junklist\
|cFF00FFFF/dt clear|r to remove all items from junklist\
|cFF00FFFF/dt help|r to print this list\
")
 end
 if var1 == 'add' and var2 ~= nil then
    if var2:find('|Hitem') == nil then
       self:Print("Command accepts only itemlinks.")
    else
      self:Add(var2, true)
    end
 elseif (var1 == 'rem' or var1 == 'remove') and var2 ~= nil then
    if var2:find('|Hitem') == nil then
      self:Print("Command accepts only itemlinks.")
    else
      self:Rem(var2, true)
    end
 end
 if (var1 == 'list' or var1 == 'junklist') then
    addon:listjunk()
 end
 if (var1 == 'clear' or var1 == 'clearjunk') then
    addon:Clearjunklist()
 end
 if var1 == nil then
    InterfaceOptionsFrame_OpenToCategory(addon.optionsFrame)
    InterfaceOptionsFrame_OpenToCategory(addon.optionsFrame)
 end
 if var1 == 'npcid' then
  local npcGuid = UnitGUID("target") or nil
  if npcGuid then
     local _, _, _, _, _, npcID = strsplit("-", npcGuid)
     self.Print("NPC_ID: "..npcID)
  end
 end
 if var1 == 'key' then
    addon:FindKey()
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Slash Commands ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ JunkSeller ]]--
---------------------------------------------------------------------------------------------------------------------------------

-----------------------------
function addon:Clearjunklist()
  if addon.db.char.C_JunkList then
     wipe(self.db.char.junklist)
     self:Print("Character Junk List cleared.")
  else
     wipe(self.db.global.junklist)
     self:Print("Global Junk List cleared.")
  end
end
-----------------------------

-----------------------------
function addon:Add(link)
 -- remove all trailing whitespace
 link = strtrim(link)
 -- extract name from an itemlink
 local found, _, name = string.find(link, "^|c%x+|H.+|h.(.*)\].+")
 -- if it's not an itemlink, guess it's name of an item
 if not found then
    name = link
 end
 if addon.db.char.C_JunkList then
    junklist = self.db.char.junklist
 else
    junklist = self.db.global.junklist
 end
 local junklist = junklist
 for k,v in pairs(junklist) do
  if v == name or v == link then
     return
   end
 end
 -- append name of the item to global junk list
 junklist[#junklist + 1] = name
 self:Print("Added" .. ": " .. link)
end
-----------------------------

-----------------------------
function addon:Rem(link)
 -- remove all trailing whitespace
 link = strtrim(link)
 -- extract name from an itemlink
 local isLink, _, name = string.find(link, "^|c%x+|H.+|h.(.*)\].+")
 -- if it's not an itemlink, guess it's name of an item
 if not isLink then
    name = link
 end
 -- looping through exceptions
 local found = false
 local _junklist
 if addon.db.char.C_JunkList then
    junklist = self.db.char.junklist
 else
    junklist = self.db.global.junklist
 end
 local junklist = junklist
 for k,v in pairs(junklist) do
  found = false
  -- comparing junklist list entry with given name
  if v:lower() == name:lower() then
     found = true
  end
  -- extract name from itemlink (only for compatibility with old saved variables)
  isLink, _, _junklist = string.find(v, "^|c%x+|H.+|h.(.*)\].+")
  if isLink then
     -- comparing junklist list entry with given name
     if _junklist:lower() == name:lower() then
        found = true
     end
  end
  if found then
     if junklist[k + 1] then
        junklist[k] = junklist[k + 1]
     else
        junklist[k] = nil
     end
      self:Print("Removed"..": "..link)
     break
   end
 end
end
-----------------------------

-----------------------------
function addon:isjunklist(link)
 local _junklist = nil
 -- extracting name of an item from the itemlink
 local isLink, _, name = string.find(link, "^|c%x+|H.+|h.(.*)\].+")
 -- it's not an itemlink, so guess it's name of the item
 if not isLink then
    name = link
 end
 if addon.db.char.C_JunkList then
    junklist = self.db.char.junklist
 else
    junklist = self.db.global.junklist
 end
 local junklist = junklist
 if junklist then
    -- looping through global junklist
    for k,v in pairs(junklist) do
        -- comparing junklist entry with given name
        if v:lower() == name:lower() then
           return true
        end
        -- extract name from itemlink (only for compatibility with old saved variables)
        isLink, _, _junklist = string.find(v, "^|c%x+|H.+|h.(.*)\].+")
        if isLink then
           -- comparing junklist entry with given name
           if _junklist:lower() == name:lower() then
              return true
           end
        end
    end
 end
 -- item not found in junklist
 return false
end
-----------------------------

-----------------------------
function addon:listjunk()
 if addon.db.char.C_JunkList then
    junklist = self.db.char.junklist
 else
    junklist = self.db.global.junklist
 end
 local junklist = junklist
 local nojunkitems = true
 for _,_ in pairs(junklist) do
    nojunkitems = false
 end
 if nojunkitems then
    self:Print("JunkList is Empty.")
 else
    if junklist then
       table.sort(junklist)
       if addon.db.char.C_JunkList then
          self:Print("===== Character JunkList =====")
       else
          self:Print("===== Global JunkList =====")
       end
       for k,v in pairs(junklist) do
           self:Print(" -- "..v)
       end
       self:Print("=============================")
    end
 end
end
-----------------------------

-----------------------------
function addon:JunkSeller()
  -- Skip selling junk if merchant does not buy items
  local npcGuid = UnitGUID("target") or nil
  if npcGuid then
     local _, _, _, _, _, npcID = strsplit("-", npcGuid)
     if npcID then
        if    npcID == "27914"   -- Ethereal Soul-Trader (pet)
           or npcID == "132514"  -- Auto-Hammer (Engineer's Repair Bot)
           or npcID == "107109"  -- Xur'ios (Vaultkeeper of the Void, Dalaran)
           or npcID == "48959"   -- Rusty Anvil (Uldum)
           or npcID == "63596"   -- Audrey Burnhep (Battle Pet Trainer, Stormwind)
           or npcID == "77368"   -- Madison Clark (Cook, Lunarfall, Alliance Garrison)
           or npcID == "87302"   -- Murg (Cook, Frostwall, Horde Garrison) (first unit ID)
           or npcID == "79828"   -- Murg (Cook, Frostwall, Horde Garrison) (second unit ID)
           or npcID == "91190"   -- Sister Elda (Keeper of the Ancient Tomes, Sanctum of Light) Palidan
           or npcID == "98737"   -- Holt Thunderhorn (Lore of the Legends, Highmountain Trueshot Lounge) Hunter         
           or npcID == "102641"  -- Filus Sparkstache (Archivist, The Chamber of Shadows) Rogue
           or npcID == "110624"  -- Edirah (Tirisgarde Researcher, Hall of the Guardian) Mage
           or npcID == "111738"  -- Juvess (The Duskwisperer,  Netherlight Temple) Priest
           or npcID == "111739"  -- Gorma Windspeaker(Keaper of Legends, The Maelstrom) Shaman
           or npcID == "111740"  -- Mile Raitheborne (Head Archivist, Dreadscar Rift) Warlock
           or npcID == "111736"  -- Vahu The Weathered (Illidari Researcher, The Fel Hammer) Demon Hunter
           or npcID == "111741"  -- Fjornson Stonecarver (Keeper of Legends, Skyhold) Warrior
           or ncpID == "111737"  -- Celadine the Fatekeeper (Dreamgrove Researcher, The Dream Grove) Druid
           or ncpID == "106942"  -- (Lorewalker Cho, Temple of Five Dawns) Monk
           or ncpID == "97111"   -- (Illanna Dreadmoore, Acherus: The Ebon Hold) Death Knight
        then
           self:Print("Can Not Sell items to this Merchant.")
           return
        end
     end
  end
  local max = 0
  local profit = 0
  local currPrice
  for bag = 0,4 do
    for slot = 1,GetContainerNumSlots(bag) do
      local item = GetContainerItemLink(bag,slot)
      if item then
        local grey = string.find(item,"|cff9d9d9d")
        if (grey and (not addon:isjunklist(item))) or ((not grey) and (addon:isjunklist(item))) then
          currPrice = select(11, GetItemInfo(item)) * select(2, GetContainerItemInfo(bag, slot))
          if currPrice > 0 then
             PickupContainerItem(bag, slot)
             PickupMerchantItem()
             self:Print("Sold"..": "..item)
             profit = profit + currPrice
             max = max + 1
             if max == 12 then
                if profit > 0 then
                   self:Print("Total Junk Sold"..": "..GetMoneyString(profit))
                local profit = 0
                end
                return
             end
          end
        end
      end
    end
  end
  if profit > 0 then
     self:Print("Total Junk Sold"..": "..GetMoneyString(profit))
  end
end
-----------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ END JunkSeller ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ AutoRepair ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:AutoRepair()
 if CanMerchantRepair() then
   local cost = GetRepairAllCost()
   if cost>0 then
      if IsInGuild() and CanGuildBankRepair() then
         local gbmoney = GetGuildBankMoney()
         local gwmoney = GetGuildBankWithdrawMoney()
         if (cost <= gbmoney) and (cost <= gwmoney or gwmoney == "-1") then
            RepairAllItems(1)
            self:Print("Auto-Repaired with Guild Funds: "..GetMoneyString(cost))
         else
            if GetMoney() > cost then
               RepairAllItems()
               self:Print("Auto-Repaired with Personal Funds: "..GetMoneyString(cost))
            else
               self:Print("Can NOT Afford Repair Bill: "..GetMoneyString(cost))
            end
         end
      else
         if GetMoney() > cost then
            RepairAllItems()
            self:Print("Auto-Repaired with Personal Funds: "..GetMoneyString(cost))
         else
            self:Print("Can NOT Afford Repair Bill: "..GetMoneyString(cost))
         end
      end
   end
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END AutoRepair ]]--
---------------------------------------------------------------------------------------------------------------------------------

--[[ Griffin Caps ]]--
function addon:hide_griffins() MainMenuBarLeftEndCap:Hide() MainMenuBarRightEndCap:Hide() end
function addon:show_griffins() MainMenuBarLeftEndCap:Show() MainMenuBarRightEndCap:Show() end
--[[ END Griffin Caps ]]--

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Chat Mods ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTChat()
--[[ Add more font sizes to chat menu ]]--
CHAT_FONT_HEIGHTS = { [1] = 10, [2] = 11, [3] = 12, [4] = 13, [5] = 14, [6] = 15, [7] = 16, [8] = 17, [9] = 18, [10] = 19, [11] = 20 }

--[[ Add scroll to top or bottom if shift key pressed and mouse scroll up/down ]]--
FloatingChatFrame_OnMouseScroll = function(self, dir)
  if(dir > 0) then
    if(IsShiftKeyDown()) then
      self:ScrollToTop()
    else
      self:ScrollUp()
    end
  else
    if(IsShiftKeyDown()) then
      self:ScrollToBottom()
    else
      self:ScrollDown()
    end
  end
end

--[[ Chat copy name ]]--
StaticPopupDialogs["COPYNAME"] = {
    text = "Use \"ctrl+c\" to Copy Name",
    button2 = CANCEL,
    hasEditBox = true,
    hasWideEditBox = true,
    timeout = 0,
    exclusive = 1,
    hideOnEscape = 1,
    EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
    whileDead = 1,
    maxLetters = 255,
}

local function insertbefore(t, before, val)
    for k,v in ipairs(t) do if v == before then return table.insert(t, k, val) end end
    table.insert(t, val)
end

local clickers = {["COPYNAME"] = function(a1) Chat_DoCopyName(a1) end}
UnitPopupButtons["COPYNAME"] = {text = "Copy Name", dist = 0}
insertbefore(UnitPopupMenus["FRIEND"], "IGNORE", "COPYNAME")

hooksecurefunc("UnitPopup_HideButtons", function()
    local dropdownMenu = UIDROPDOWNMENU_INIT_MENU
    for i,v in pairs(UnitPopupMenus[dropdownMenu.which]) do
        if clickers[v] then UnitPopupShown[i] = (dropdownMenu.name == UnitName("player") and 0) or 1 end
    end
end)

hooksecurefunc("UnitPopup_OnClick", function(self)
    local dropdownFrame = UIDROPDOWNMENU_INIT_MENU
    local button = self.value
    if clickers[button] then clickers[button](dropdownFrame.name) end
    PlaySound("UChatScrollButton")
end)

function Chat_DoCopyName(name)
    local dialog = StaticPopup_Show("COPYNAME")
    local editbox = _G[dialog:GetName().."EditBox"]
    editbox:SetText(name or "")
    editbox:SetFocus()
    editbox:HighlightText()
    local button = _G[dialog:GetName().."Button2"]
    button:ClearAllPoints()
    button:SetPoint("CENTER", editbox, "CENTER", 0, -30)
end

--[[ Url link pop up window to copy ]]--
function doColor(url)
    url = " |cff99FF33|Hurl:"..url.."|h["..url.."]|h|r "
    return url
end

function urlFilter(self, event, msg, author, ...)
    if strfind(msg, "(%a+)://(%S+)%s?") then
        return false, gsub(msg, "(%a+)://(%S+)%s?", doColor("%1://%2")), author, ...
    end
    if strfind(msg, "www%.([_A-Za-z0-9-]+)%.(%S+)%s?") then
        return false, gsub(msg, "www%.([_A-Za-z0-9-]+)%.(%S+)%s?", doColor("www.%1.%2")), author, ...
    end
    if strfind(msg, "([_A-Za-z0-9-%.]+)@([_A-Za-z0-9-]+)(%.+)([_A-Za-z0-9-%.]+)%s?") then
        return false, gsub(msg, "([_A-Za-z0-9-%.]+)@([_A-Za-z0-9-]+)(%.+)([_A-Za-z0-9-%.]+)%s?", doColor("%1@%2%3%4")), author, ...
    end
    if strfind(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?):(%d%d?%d?%d?%d?)%s?") then
        return false, gsub(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?):(%d%d?%d?%d?%d?)%s?", doColor("%1.%2.%3.%4:%5")), author, ...
    end
    if strfind(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%s?") then
        return false, gsub(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%s?", doColor("%1.%2.%3.%4")), author, ...
    end
    if strfind(msg, "[wWhH][wWtT][wWtT][\46pP]%S+[^%p%s]") then
        return false, gsub(msg, "[wWhH][wWtT][wWtT][\46pP]%S+[^%p%s]", doColor("%1")), author, ...
    end
end

StaticPopupDialogs["LINKME"] = {
    text = "Use \"ctrl+c\" to Copy URL",
    button2 = CANCEL,
    hasEditBox = true,
    hasWideEditBox = true,
    timeout = 0,
    exclusive = 1,
    hideOnEscape = 1,
    EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
    whileDead = 1,
    maxLetters = 255,
}

local SetHyperlink = _G.ItemRefTooltip.SetHyperlink
function _G.ItemRefTooltip:SetHyperlink(link, ...)
    if link and (strsub(link, 1, 3) == "url") then
        local url = strsub(link, 5)
        local dialog = StaticPopup_Show("LINKME")
        local editboxa = _G[dialog:GetName().."EditBox"]

        editboxa:SetText(url)
        editboxa:SetFocus()
        editboxa:HighlightText()

        local button = _G[dialog:GetName().."Button2"]
        button:ClearAllPoints()
        button:SetPoint("CENTER", editboxa, "CENTER", 0, -30)

        return
     end

     SetHyperlink(self, link, ...)
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND_LEADER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_CONVERSATION", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING", urlFilter)

ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BATTLEGROUND", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", urlFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", urlFilter)

--[[ Add alt click invite player -- alt click player in chat to invite to group ]]--
 hooksecurefunc("SetItemRef", function(link)
  if IsAltKeyDown() then
   local player = link:match("^player:([^:]+)")
   InviteToGroup(player)
   -- We use a secure hook to stay clean (avoid taint), but this means a whisper window will open, so we close it.
   ChatEdit_OnEscapePressed(ChatFrame1EditBox)
  end
 end)

--[[ Removes the need hold down [alt] key when moving left and right with cursor keys in the chat editbox.
     You will still need to hold down [alt] key to arrow up or down through chat history. ]]--
for chatwin=1,NUM_CHAT_WINDOWS do
 chatwin=_G["ChatFrame"..chatwin.."EditBox"]
 chatwin:SetAltArrowKeyMode(false)
end

--[[ Channel Replacement alias to shorten names ]]--
CHAT_SAY_GET = "[S] %s: "
CHAT_YELL_GET = "[Y] %s: "
CHAT_WHISPER_GET = "[F] %s: "
CHAT_WHISPER_INFORM_GET = "[T] %s: "

CHAT_FLAG_AFK = "[AFK] "
CHAT_FLAG_DND = "[DND] "
CHAT_FLAG_GM = "[GM] "

CHAT_MONSTER_PARTY_GET = CHAT_PARTY_GET
CHAT_MONSTER_SAY_GET = CHAT_SAY_GET
CHAT_MONSTER_WHISPER_GET = CHAT_WHISPER_GET
CHAT_MONSTER_YELL_GET = CHAT_YELL_GET

local gsub = gsub
local time = _G.time
local newAddMsg = {}

local rplc = {
  "[GEN]", --General
  "[T]",   --Trade
  "[WD]",  --WorldDefense
  "[LD]",  --LocalDefense
  "[LFG]", --LookingForGroup
  "[GR]",  --GuildRecruitment
  "[I]",   --Instance
  "[IL]",  --Instance Leader
  "[G]",   --Guild
  "[P]",   --Party
  "[PL]",  --Party Leader
  "[PL]",  --Party Leader (Guide)
  "[O]",   --Officer
  "[R]",   --Raid
  "[RL]",  --Raid Leader
  "[RW]",  --Raid Warning
  "[%1]",  --Custom Channels
}

local chn = {
  "%[%d0?%. General.-%]",
  "%[%d0?%. Trade.-%]",
  "%[%d0?%. WorldDefense%]",
  "%[%d0?%. LocalDefense.-%]",
  "%[%d0?%. LookingForGroup%]",
  "%[%d0?%. GuildRecruitment.-%]",
  gsub(CHAT_INSTANCE_CHAT_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_INSTANCE_CHAT_LEADER_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_GUILD_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_PARTY_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_PARTY_LEADER_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_PARTY_GUIDE_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_OFFICER_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_RAID_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_RAID_LEADER_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  gsub(CHAT_RAID_WARNING_GET, ".*%[(.*)%].*", "%%[%1%%]"),
  "%[(%d0?)%. (.-)%]",   --Custom Channels
}

local AddMessage = function(frame, text, ...)
  for i = 1, 17 do
      text = gsub(text, chn[i], rplc[i])
  end
  --If Blizz timestamps is enabled, stamp anything it misses
  if CHAT_TIMESTAMP_FORMAT and not text:find("^|r") then
     text = BetterDate(CHAT_TIMESTAMP_FORMAT, time())..text
  end
  text = gsub(text, "%[(%d0?)%. .-%]", "[%1]") --custom channels
  return newAddMsg[frame:GetName()](frame, text, ...)
end
for i = 1, 10 do
    local fcl = _G[format("%s%d", "ChatFrame", i)]
    --skip combatlog and frames with no messages registered
    if i ~= 2 then -- skip combatlog
       newAddMsg[format("%s%d", "ChatFrame", i)] = fcl.AddMessage
       fcl.AddMessage = AddMessage
    end
end

--[[ Chat fade hide ]]--
 CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0
 CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 0
 CHAT_FRAME_BUTTON_FRAME_MIN_ALPHA = 0
 for i=1, 10 do
  local tab = _G[format("%s%d%s", "ChatFrame", i, "Tab")]
  tab:SetAlpha(0)
  tab.noMouseAlpha = 0
 end

--[[ Disable tab flashing. ]]--
  FCF_FlashTab = function() end
  FCFTab_UpdateAlpha = function() end

--[[ Font outline ]]--
for i = 1, 10 do
  local cF = _G[format("%s%d", "ChatFrame", i)]
  local font, size = cF:GetFont()
  cF:SetFont(font, size, "OUTLINE")
end

--[[ Misc functions (Frame size/move,Arrow keys,editbox to the top). ]]--
for i = 1, NUM_CHAT_WINDOWS do
    local editBoxleft = _G[format("%s%d%s", "ChatFrame", i, "EditBoxLeft")]
    local editBoxright = _G[format("%s%d%s", "ChatFrame", i, "EditBoxRight")]
    local editBoxmid = _G[format("%s%d%s", "ChatFrame", i, "EditBoxMid")]
    editBoxleft:SetAlpha(1)
    editBoxright:SetAlpha(1)
    editBoxmid:SetAlpha(1)
end

 --Classic mode hides the editbox when not in use, IM mode fades it out
 --since we move the editbox above the chat tabs, we don't want it always showing
SetCVar("chatStyle", "classic")
for i = 1, 10 do
    local eb =  _G[format("%s%d%s", "ChatFrame", i, "EditBox")]
    local cfs = _G[format("%s%d", "ChatFrame", i)]
    --Allow resizing chatframes to whatever size you wish!
    cfs:SetMinResize(100,10)
    cfs:SetMaxResize(0,0)
    --Allow the chat frame to move to the end of the screen
    cfs:SetClampRectInsets(0,0,0,0)
    eb:SetAltArrowKeyMode(false)

    eb:ClearAllPoints()
    eb:SetPoint("BOTTOMLEFT",  cfs, "TOPLEFT",  -5, 0)
    eb:SetPoint("BOTTOMRIGHT", cfs, "TOPRIGHT", 5, 0)
    eb:Hide() --call this incase we're just changing to classic mode for the first time
end

--[[ Chat copy ]]--
local frame = CreateFrame("Frame", "wCopyFrame", UIParent)
frame:SetBackdrop({
  bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
  edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
  edgeSize = 16, tileSize = 16, tile = true,
  insets = { left = 1, right = 1, top = 1, bottom = 1 }
})
frame:SetBackdropColor(0,0,0,1)
frame:SetWidth(650)
frame:SetHeight(500)
frame:SetPoint("CENTER", UIParent, "CENTER")
frame:Hide()
frame:SetFrameStrata("DIALOG")

local scrollArea = CreateFrame('ScrollFrame', "wCopyScroll", frame, 'UIPanelScrollFrameTemplate')
scrollArea:SetPoint("TOPLEFT", frame, "TOPLEFT", 8, -5)
scrollArea:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -30, 5)

local group = scrollArea:CreateAnimationGroup()
local update = group:CreateAnimation()
group:SetScript("OnFinished", function() wCopyScroll:SetVerticalScroll((wCopyScroll:GetVerticalScrollRange()) or 0) end)
update:SetOrder(1)
update:SetDuration(0.25)
wCopyScroll.ScrollToBottom = group

local editBox = CreateFrame("EditBox", "wCopyBox", frame)
editBox:SetMultiLine(true)
editBox:SetMaxLetters(99999)
editBox:EnableMouse(true)
editBox:SetAutoFocus(false)
editBox:SetFontObject(ChatFontNormal)
editBox:SetWidth(620)
editBox:SetHeight(495)
editBox:SetScript("OnEscapePressed", function(f) f:GetParent():GetParent():Hide() f:SetText("") end)

scrollArea:SetScrollChild(editBox)

local close = CreateFrame('Button', "wCloseButton", frame, 'UIPanelCloseButton')
close:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, 25)

local CopyChat = function(self, chatTab)
 local chatFrame = _G['ChatFrame' .. chatTab:GetID()]
 local numMessages = chatFrame:GetNumMessages()
 if numMessages >= 1 then
  local GetMessageInfo = chatFrame.GetMessageInfo
  local text = GetMessageInfo(chatFrame, 1)
  for index = 2, numMessages do
   text = text .. "\n" .. GetMessageInfo(chatFrame, index)
  end
  frame:Show()
  editBox:SetText(text)
 end
end
hooksecurefunc('FCF_Tab_OnClick', function(self)
 local info = UIDropDownMenu_CreateInfo()
 info.text = "Open Copy Chat Window"
 info.notCheckable = true
 info.func = CopyChat
 info.arg1 = self
 UIDropDownMenu_AddButton(info)
end)
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Chat Mods ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Map Cords ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTMapCords()
 local Coords_UpdateInterval = 0.2 timeSinceLastUpdate = 0
 --[[ Setup event frame ]]--
 local Coords_eventFrame = CreateFrame("Frame")
 Coords_eventFrame:RegisterEvent("VARIABLES_LOADED")
 Coords_eventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
 Coords_eventFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
 Coords_eventFrame:RegisterEvent("ZONE_CHANGED")
 Coords_eventFrame:SetScript("OnEvent",function(self,event,...) self[event](self,event,...);end)
 --[[ Parse events handlers ]]--
 function Coords_eventFrame:VARIABLES_LOADED()
     Coords_eventFrame:SetScript("OnUpdate", function(self, elapsed) Coords_OnUpdate(self, elapsed) end)
 end
 function Coords_eventFrame:ZONE_CHANGED_NEW_AREA()
     Coords_UpdateCoords()
 end
 function Coords_eventFrame:ZONE_CHANGED_INDOORS()
     Coords_UpdateCoords()
 end
 function Coords_eventFrame:ZONE_CHANGED()
     Coords_UpdateCoords()
 end
 --[[ OnUpdate ]]--
 function Coords_OnUpdate(self, elapsed)
     timeSinceLastUpdate = timeSinceLastUpdate + elapsed
     if (timeSinceLastUpdate > Coords_UpdateInterval) then
         -- Update the update time
         timeSinceLastUpdate = 0
         Coords_UpdateCoords()
     end
 end
 --[[ WorldMapCoords ]]--
 function Coords_UpdateCoords()
     if (WorldMapFrame:IsVisible()) then
         if (IsInInstance()) then
            playerWMText = ""
         else
            --[[ Calculate Player position ]]--
            local _P = GetUnitName("player")
            local playerX, playerY = GetPlayerMapPosition("player")
            if playerX == 0 and playerY == 0 then
               playerWMText = ""
            else
               playerWMText = " | ".._P..": ("..format("%.1f, %.1f", playerX * 100, playerY * 100)..")"
            end
         end
         --[[ Calculate Cursor position ]]--
         if (IsInInstance()) then
            cursorWMText = ""
         else
            local cursorX, cursorY = GetCursorPosition()
            local scale = WorldMapDetailFrame:GetEffectiveScale()
            cursorX = cursorX / scale
            cursorY = cursorY / scale
            local width = WorldMapDetailFrame:GetWidth()
            local height = WorldMapDetailFrame:GetHeight()
            local left = WorldMapDetailFrame:GetLeft()
            local top = WorldMapDetailFrame:GetTop()
            cursorX = (cursorX - left) / width * 100
            cursorY = (top - cursorY) / height * 100
            if cursorX < 0 or cursorY < 0 or cursorX > 100 or cursorY > 100 then
               cursorWMText = ""
            else
              cursorWMText = " | Cursor: ("..format("%.1f, %.1f", cursorX, cursorY)..")"
            end
         end
         --[[ Add text to world map top border ]]--
         WorldMapFrame.BorderFrame.TitleText:SetText(MAP_AND_QUEST_LOG ..playerWMText ..cursorWMText)
     end
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Map Cords ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Micro_Button_Tips ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTMicro_Button_Tips()
 --[[ orginal addon code by Project Manager: Maldarius found @ http://www.curse.com/addons/wow/bettertooltips
      January 2015 updated for WOD by D0wntown
      May 05 2015 update guild tooltip to auto update on mouse over
      Dec 01 2015 set tooltips not to show in combat ]]--

 DTweaks_Micro_Button_Tips = LibStub("AceAddon-3.0"):NewAddon("DTweaks_Micro_Button_Tips", "AceHook-3.0");

 --[[ LOCAL FUNCTIONS AND HOOKS ]]--
 local function levelcolor(level)
  if level then
     local color = GetQuestDifficultyColor(level)
     return string.format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
  end
 end

 local colors = {}
 for class,color in pairs(RAID_CLASS_COLORS)
  do colors[class] = string.format("%02x%02x%02x", color.r*255, color.g*255, color.b*255);
 end

 function DTweaks_Micro_Button_Tips:OnInitialize()
 --
 end

 function DTweaks_Micro_Button_Tips:OnEnable()
  self:SecureHookScript(CharacterMicroButton, "OnEnter", "OnMouseOverCharacter");
  self:SecureHookScript(SpellbookMicroButton, "OnEnter", "OnMouseOverSpellbook");
  self:SecureHookScript(GuildMicroButton, "OnEnter", "OnMouseOverGuild");
 end

 function DTweaks_Micro_Button_Tips:OnDisable()
  self:UnHookAll();
 end

 --[[ CHARACTER INFO TOOLTIP ]]--
 function DTweaks_Micro_Button_Tips:OnMouseOverCharacter()
  if (UnitAffectingCombat("player")) then
  --
  else
     --[[ Currency Vars ]]--
     local numCurTypes = GetCurrencyListSize()
     local LegionCurrencyCnt = 0;
     local DraenorCurrencyCnt = 0;
     --[[ Legion Currency ]]--
     for i = 1, numCurTypes, 1 do
      -- name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown = GetCurrencyListInfo(index)
      local name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown = GetCurrencyListInfo(i);
      if ((count > 0) and (name == "Order Resources" or name == "Ancient Mana" or name == "Sightless Eye" or name == "Curious Coin" or name == "Lingering Soul Fragment" or name == "Timeworn Artifact" or name == "Nethershard")) then
          if LegionCurrencyCnt == 0 then
             GameTooltip:AddLine("Legion Currency: Total / Maximum");
          end
          if maximum == 0 then
              GameTooltip:AddDoubleLine("|cffffffff "..name.."|r","|cffffffff"..("%d%s|T%s:0|t"):format(count," / NA  ",icon).."|r");
          else
              GameTooltip:AddDoubleLine("|cffffffff "..name.."|r","|cffffffff"..("%d%s%d%s|T%s:0|t"):format(count," / ",maximum,"  ",icon).."|r");
          end
          LegionCurrencyCnt = LegionCurrencyCnt + 1
      end
      --[[ Draenor Currency ]]--
      if ((count > 0) and (name == "Apexis Crystal" or name == "Artifact Fragment" or name == "Dingy Iron Coins" or name == "Garrison Resources" or name == "Oil" or name == "Seal of Inevitable Fate" or name == "Seal of Tempered Fate" or name == "Valor")) then
          if DraenorCurrencyCnt == 0 then
             GameTooltip:AddLine(" ");
             GameTooltip:AddLine("Draenor Currency: Total / Maximum");
          end
          if maximum == 0 then
             GameTooltip:AddDoubleLine("|cffffffff "..name.."|r","|cffffffff"..("%d%s|T%s:0|t"):format(count," / NA  ",icon).."|r");
          else
             GameTooltip:AddDoubleLine("|cffffffff "..name.."|r","|cffffffff"..("%d%s%d%s|T%s:0|t"):format(count," / ",maximum,"  ",icon).."|r");
          end
          DraenorCurrencyCnt = DraenorCurrencyCnt + 1
      end
     end
     --[[ Other Items to watch if item count over 1 ]]--
     local drownedmanacount = GetItemCount("Drowned Mana",true)
     if (drownedmanacount > 1) then
         GameTooltip:AddLine(" ");
         GameTooltip:AddLine("Additional Tracked Items:");
     end
     if drownedmanacount > 1 then
        local count = drownedmanacount icon = GetItemIcon("Drowned Mana") name = "Drowned Mana"
        GameTooltip:AddDoubleLine("|cffffffff "..name.."|r","|cffffffff"..("%d%s|T%s:0|t"):format(count,"  ",icon).."|r");
     end
     GameTooltip:AddLine(" ");
     GameTooltip:Show();
  end
 end

 --[[ SPELLBOOK & ABILITIES TOOLTIP ]]--
 local function AddSkillToTooltip(skillid, fallback)
 if (UnitAffectingCombat("player")) then
 --
 else
  if not skillid then
     return GameTooltip:AddDoubleLine(fallback, "See Trainer!");
  else
     local name,icon,skillLevel,maxSkillLevel,numAbilities,spelloffset,skillLine,skillModifier,specializationIndex,specializationOffset = GetProfessionInfo(skillid);
     if (skillLevel <= maxSkillLevel) then
        if (skillModifier ~= 0) then
           skillLevel = "|cff00ff00"..("%d"):format(skillLevel + skillModifier).."|r (|cffeeeeee"..("%d"):format(skillLevel).."+|r|cff00ff00"..("%d"):format(skillModifier).."|r)";
        else
           skillLevel = "|cffeeeeee"..("%d"):format(skillLevel).."|r";
        end
     else
        skillLevel = ("%d"):format(skillLevel);
     end
     GameTooltip:AddDoubleLine(("|cffffffff"..("|T%s:0|t%s"):format(icon, "  "..name).."|r"),(skillLevel..("/%d"):format(maxSkillLevel)));
  end
 end
 end

 function DTweaks_Micro_Button_Tips:OnMouseOverSpellbook()
 if (UnitAffectingCombat("player")) then
 --
 else
  local prof1, prof2, arch, fish, cook, firstAid = GetProfessions();
  GameTooltip:AddLine(" ");
  GameTooltip:AddLine("Professions");
  AddSkillToTooltip(prof1, PROFESSIONS_FIRST_PROFESSION);
  AddSkillToTooltip(prof2, PROFESSIONS_SECOND_PROFESSION);
  AddSkillToTooltip(arch, PROFESSIONS_ARCHAEOLOGY);
  AddSkillToTooltip(fish, PROFESSIONS_FISHING);
  AddSkillToTooltip(cook, PROFESSIONS_COOKING);
  AddSkillToTooltip(firstAid, PROFESSIONS_FIRST_AID);
  GameTooltip:Show();
  end
 end

 --[[ GUILD TOOLTIP ]]--
 function DTweaks_Micro_Button_Tips:OnMouseOverGuild()
 if (UnitAffectingCombat("player")) then
 --
 else
  GuildRoster()
  if IsInGuild() then
     -- class, level, name, note, online, rank, zone
     if ( IsShiftKeyDown() ) then
        SortGuildRoster("level")
     elseif ( IsAltKeyDown() ) then
        SortGuildRoster("zone")
     else
        SortGuildRoster("name")
     end
     local guildName,guildRankName,guildRankIndex = GetGuildInfo("player");
     local numTotal,numOnlineMaxLevel,numOnline = GetNumGuildMembers();
     local _Realm = GetRealmName()
     local sMsg = "";
     if (numOnline) == 1 then
        sMsg = "  1 Guildie Online";
     elseif numOnline < 10 then
        sMsg = string.format("   %1d   Guildies Online", numOnline);
     elseif numOnline < 100 then
        sMsg = string.format("  %2d   Guildies Online", numOnline);
     elseif numOnline < 1000 then
        sMsg = string.format(" %3d   Guildies Online", numOnline);
     else
        sMsg = " unknown Guildies Online ";
     end
     GameTooltip:AddLine("|cffffffff"..guildName.." @ ".._Realm.."|r");
     GameTooltip:AddLine(" ");
     for i = 1, numOnline, 1 do
      --  fullName, rank, rankIndex, level, class, zone, note, officernote, online, isAway, classFileName, achievementPoints, achievementRank, isMobile =  GetGuildRosterInfo(i);
         local fullName,_,_,level,_,zone,_,_,online,_,classFileName,_,_,isMobile = GetGuildRosterInfo(i);
         if online or isMobile then
            if isMobile then zone = "Remote Chat" end
               Name = fullName:gsub("%-.+", "")
               if level < 10 then
                  GameTooltip:AddDoubleLine(("|cff"..levelcolor(level)..string.format("  %3d", level).."|r".."   "..string.format("|cff%s%s", colors[classFileName] or "ffffff", Name).."|r"),(zone));
               elseif level < 100 then
                      GameTooltip:AddDoubleLine(("|cff"..levelcolor(level)..string.format(" %3d", level).."|r".."   "..string.format("|cff%s%s", colors[classFileName] or "ffffff", Name).."|r"),(zone));
               else
                      GameTooltip:AddDoubleLine(("|cff"..levelcolor(level)..string.format("%3d", level).."|r".."   "..string.format("|cff%s%s", colors[classFileName] or "ffffff", Name).."|r"),(zone));
               end
         end
     end
     GameTooltip:AddLine(" ");
     GameTooltip:AddLine("|cffffffff"..sMsg.."|r");
  else
     GameTooltip:AddLine("You are not currently in a Guild.");
     GameTooltip:AddLine(" ");
     GameTooltip:AddLine("If you join a Guild, Information about your online Guildies will appear in this tooltip.");
  end
  GameTooltip:Show();
 end
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Micro_Button_Tips ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Auto_Select_QuestReward ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTAuto_Select_QuestReward()
 --[[ Auto Select Higest Vendor Value Quest Reward ]]--
 local Frame = CreateFrame('Frame', 'DTweaks_SellQuestItem') wait_time = 0.20 time_spent = 0
 
 local function SelectItem()
  local high_val_item = 0
  for I=1, GetNumQuestChoices() do
      local next_val_item = select(11, GetItemInfo(GetQuestItemLink('choice', I)))
      if next_val_item > high_val_item then
         high_val_item = next_val_item
         _G['QuestInfoRewardsFrameQuestInfoItem'..I]:Click()
         link, _, _, _ = GetQuestItemLink("choice", I)
         coins = GetCoinTextureString(high_val_item,"12")
      end
  end
      if coins then
         ChatFrame1:AddMessage(string.format("|cFF00FF00DTweaks |r|cFFFFCC00Highest Vendor Item |r"..link.."|cFF00FF00 |r"..coins))
      end
 end
 
 local function OnUpdate(self, elapsed)
  time_spent = time_spent + elapsed
  if time_spent > wait_time then
     Frame:SetScript("OnUpdate", nil)
     SelectItem()
  end
 end
 
 Frame:RegisterEvent('QUEST_COMPLETE')
 Frame:SetScript('OnEvent', function(self, event, ...)
 if GetNumQuestChoices() > 0 then
    time_spent = 0
    Frame:SetScript("OnUpdate", OnUpdate)
 end
 end)
end

---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Auto_Select_QuestReward ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks AutoRepSwitch ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTAutoRepSwitch()
--[[ The orginal Addon Code by Project Manager: Dridzt found @ http://www.curse.com/addons/wow/autorepswitch, updated: Jan 2014, (by D0wntown for WOD) ]]--
local f = CreateFrame("Frame")

local strMatchCombat = {}
tinsert(strMatchCombat, (string.gsub(FACTION_STANDING_INCREASED,"%%%d?%$?s", "(.+)")))
tinsert(strMatchCombat, (string.gsub(FACTION_STANDING_INCREASED_GENERIC,"%%%d?%$?s", "(.+)")))
tinsert(strMatchCombat, (string.gsub(FACTION_STANDING_INCREASED_BONUS,"%%%d?%$?s", "(.+)")))
tinsert(strMatchCombat, (string.gsub(FACTION_STANDING_INCREASED_DOUBLE_BONUS,"%%%d?%$?s", "(.+)")))
tinsert(strMatchCombat, (string.gsub(FACTION_STANDING_INCREASED_ACH_BONUS,"%%%d?%$?s", "(.+)")))
local strChangeMatch = (string.gsub(FACTION_STANDING_CHANGED,"%%%d?%$?s", "(.+)"))
local strGuildChangeMatch = {}
tinsert(strGuildChangeMatch, (string.gsub(FACTION_STANDING_CHANGED_GUILD,"%%%d?%$?s", "(.+)")))
tinsert(strGuildChangeMatch, (string.gsub(FACTION_STANDING_CHANGED_GUILDNAME,"%%%d?%$?s", "(.+)")))

local collapsed = {}
local guildName

f:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
f:RegisterEvent("COMBAT_TEXT_UPDATE")
f:RegisterEvent("CHAT_MSG_SYSTEM")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("PLAYER_GUILD_UPDATE")

f:SetScript("OnEvent",
function(self, event, ...)
 if self[event] then
    return self[event](...)
 end
end)

local function setWatchedFaction(faction)
--  print("ARS Debug(sWF):"..faction)
 wipe(collapsed)
 local i,j = 1, GetNumFactions()
 while i <= j do
        -- name,description,standingID,barMin,barMax,barValue,atWarWith,canToggleAtWar,isHeader,isCollapsed,hasRep,isWatched,isChild,factionID,hasBonusRepGain,canBeLFGBonus = GetFactionInfo(index)
  local name,_,_,_,_,_,_,_,isHeader,isCollapsed,_,isWatched,_,_,_,_ = GetFactionInfo(i)
  if name == faction then
   if not (isWatched or IsFactionInactive(i)) then
      SetWatchedFactionIndex(i)
   end
   break
  end
  if isHeader and isCollapsed then
     ExpandFactionHeader(i)
     collapsed[i] = true
     j = GetNumFactions()
  end
  i = i+1
 end
 -- let's clean up after ourselves
 if next(collapsed) then
    for k=i,1,-1 do
     if collapsed[k] then
        CollapseFactionHeader(k)
     end
    end
 end
end

function f.GUILD_ROSTER_UPDATE()
 if IsInGuild() then
    guildName = (GetGuildInfo("player"))
 end
 if guildName then
    f:UnregisterEvent("GUILD_ROSTER_UPDATE")
 end
end
function f.PLAYER_GUILD_UPDATE()
 if IsInGuild() then
    guildName = (GetGuildInfo("player"))
  if not guildName then
     f:RegisterEvent("GUILD_ROSTER_UPDATE")
  end
 else
   guildName = nil
 end
end

function f.PLAYER_LOGIN()
 if IsInGuild() then
    guildName = (GetGuildInfo("player"))
  if not guildName then
     f:RegisterEvent("GUILD_ROSTER_UPDATE")
  end
 end
end

function f.CHAT_MSG_SYSTEM(...)
 local messg = ...
 local found
 local newfaction = (string.match(messg,strChangeMatch)) and select(2,string.match(messg,strChangeMatch))
 if newfaction then
--     print("ARS Debug(CMS):"..tostring(newfaction))
   if guildName and (newfaction == GUILD) then
      found = guildName
   else
      found = newfaction
   end
 else
    local guildfaction -- = (string.match(messg,strGuildChangeMatch))
    for i, v in ipairs(strGuildChangeMatch) do
     guildfaction = (string.match(messg,strGuildChangeMatch[i]))
     if guildfaction then
--      print("ARS Debug(CMS)G:"..tostring(guildName).."/"..guildfaction)
        break
     end
    end
  if guildfaction and guildName then
     found = guildName
  end
 end
 if found then
    setWatchedFaction(found)
 end
end

function f.COMBAT_TEXT_UPDATE(...)
 local messagetype, faction, amount = ...
 if messagetype ~= "FACTION" then return end
 if (not amount) or (amount<0) then return end
--   print("ARS Debug(CTU):"..tostring(faction).."/"..tostring(amount))
 if GUILD and faction and guildName and (faction == GUILD) then
    faction = guildName
 end
 if faction then
    setWatchedFaction(faction)
 end
end

function f.CHAT_MSG_COMBAT_FACTION_CHANGE(...)
 local messg = ...
 local found
 for i, v in ipairs(strMatchCombat) do
  found = (string.match(messg,strMatchCombat[i]))
--    print("ARS Debug(CMCFC):"..tostring(found))
  if found then
     if GUILD and guildName and (found == GUILD) then
        found = guildName
     end
     break
  end
 end
 if found then
    setWatchedFaction(found)
 end
end
--[[ EOF ]]--
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks AutoRepSwitch ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks CastBar_Timer ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTCastBar_Timer()
 CastingBarFrame.timer = CastingBarFrame:CreateFontString(nil);
 CastingBarFrame.timer:SetFont(STANDARD_TEXT_FONT,12,"OUTLINE");
 -- Place Timer on Top of casting bar "CastingBarFrame.timer:SetPoint("BOTTOM", CastingBarFrame, "TOP", 0, 8);"
 -- Place Timer on Bottom of casting bar "CastingBarFrame.timer:SetPoint("TOP", CastingBarFrame, "BOTTOM", 0, -2);"
 CastingBarFrame.timer:SetPoint("TOP", CastingBarFrame, "BOTTOM", 0, -2);
 CastingBarFrame.update = .1;
 
 CastingBarFrame:HookScript("OnUpdate", function(self, elapsed)
  if not self.timer then return end
  if self.update and self.update < elapsed then
     if self.casting then
        self.timer:SetText(format("%2.1f/%1.1f", max(self.maxValue - self.value, 0), self.maxValue))
     elseif self.channeling then
        self.timer:SetText(format("%.1f", max(self.value, 0)))
     else
        self.timer:SetText("")
     end
     self.update = .1
  else
     self.update = self.update - elapsed
  end
 end)
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks CastBar_Timer ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Durability_ItemLevel_Chants ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTDurability_ItemLevel_Chants()
if IsAddOnLoaded("Durability") then return end
DT_Durability = LibStub("AceAddon-3.0"):NewAddon("DT_Durability", "AceEvent-3.0", "AceBucket-3.0", "AceHook-3.0")
local self, DT_Durability = DT_Durability, DT_Durability
local _G = _G
local I = LibStub("LibItemUpgradeInfo-1.0")
local SlotDurStrs = {}
local SlotCheckedStrs = {}
local items = { "Head", "Shoulder", "Chest", "Waist", "Legs", "Feet", "Wrist", "Hands", "MainHand", "SecondaryHand" }
local checkedItems = { "Head", "Neck", "Shoulder", "Chest", "Waist", "Legs", "Feet", "Wrist", "Hands", "Back", "Finger0", "Finger1", "Trinket0", "Trinket1", "MainHand", "SecondaryHand" }

function GetDurStrings(name)
 if(not SlotDurStrs[name]) then
  local slot = _G["Character" .. name .. "Slot"]
  SlotDurStrs[name] = slot:CreateFontString(nil, "OVERLAY")
  font, _, flags = GameFontNormal:GetFont()
  SlotDurStrs[name]:SetFont(font, 14, "OUTLINE")
  SlotDurStrs[name]:SetPoint("BOTTOMRIGHT", slot, "BOTTOMRIGHT", 3, 0)
 end
 return SlotDurStrs[name]
end

function GetCheckedStrings(name)
 if(not SlotCheckedStrs[name]) then
  local slot = _G["Character" .. name .. "Slot"]
  SlotCheckedStrs[name] = slot:CreateFontString(nil, "OVERLAY")
  font, _, flags = GameFontNormal:GetFont()
  SlotCheckedStrs[name]:SetFont(font, 14, "OUTLINE")
  SlotCheckedStrs[name]:SetPoint("TOPLEFT", slot, "TOPLEFT", 1, 0)
 end
 return SlotCheckedStrs[name]
end

function GetThresholdColour(percent)
 if percent < 0 then
  return 1, 0, 0
 elseif percent <= 0.5 then
  return 1, percent * 2, 0
 elseif percent >= 1 then
  return 0, 1, 0
 else
  return 2 - percent * 2, 1, 0
 end
end

function DT_Durability:UpdateDurability()
 for _, item in ipairs(items) do
  local id, _ = GetInventorySlotInfo(item .. "Slot")
  local v1, v2 = GetInventoryItemDurability(id)
  v1, v2 = tonumber(v1) or 0, tonumber(v2) or 0
  local percent = v1 / v2
  local SlotDurStr = GetDurStrings(item)

  if ((v2 ~= 0) and (percent ~= 1)) then

   SlotDurStr:SetText('')
   if(ceil(percent * 100) < 100)then
    SlotDurStr:SetTextColor(GetThresholdColour(percent))
    SlotDurStr:SetText(ceil(percent * 100) .. "%")
   end
  else
   SlotDurStr:SetText('')
  end
 end
end

local function getArtifactIlvl()
 local mainIlvl, offIlvl = 0, 0
 local mainQ = GetInventoryItemQuality("player", 16)
 local offQ = GetInventoryItemQuality("player", 17)

 if (mainQ or offQ) and (mainQ == 6 or offQ == 6) then
  mainIlvl = I:GetUpgradedItemLevel(GetInventoryItemLink("player", 16)) or 0
  offIlvl = I:GetUpgradedItemLevel(GetInventoryItemLink("player", 17)) or 0
 end
 return math.max(mainIlvl, offIlvl)
end

function DT_Durability:CheckItem()
    for _, item in ipairs(checkedItems) do
        local id, _ = GetInventorySlotInfo(item .. "Slot")
        local itemLink = GetInventoryItemLink("player", id)
        if itemLink then
            local str = ""
            -- ilevel
            local SlotCheckedStrs = GetCheckedStrings(item)
            local iLevel = I:GetUpgradedItemLevel(itemLink)
            if iLevel then
                local iQualityColor = select(4, GetItemQualityColor(GetInventoryItemQuality("player", id)))
                if (id == 16 or id == 17) and getArtifactIlvl() ~= 0 then -- Artifact equipped
                    iLevel = getArtifactIlvl()
                end
                str = "|c" .. iQualityColor .. iLevel .. "|r"
                -- gem & enchant
                if iLevel >= 800 then
                    local itemStats = GetItemStats(itemLink)
                    local g = 1
                    local e = 1
                    for k,v in pairs(itemStats) do
                        if k == "EMPTY_SOCKET_PRISMATIC" then
                            if not(GetItemGem(itemLink, 1)) then g = 0 end
                        end
                    end
                    table.wipe(itemStats)
                    if item == "Neck" or item == "Back" or item == "Finger0" or item == "Finger1" or item == "Shoulder" then
                        local data = select(3, strsplit("|", itemLink))
                        local enchant = select(3, strsplit(':', data))
                        if enchant == "" then e = 0 end
                    end
                    local result = tonumber(g .. e)
                    if result == 10 then
                        str = str .. " |cffff0000E|r"
                    elseif result == 01 then
                        str = str .. " |cffff0000G|r"
                    elseif result == 00 then
                        str = str .. " |cffff0000EG|r"
                    end
                end
                SlotCheckedStrs:SetText(str)
            else
                SlotCheckedStrs:SetText('')
            end
        else
            GetCheckedStrings(item):SetText('')
        end
    end
end

function DT_Durability:OnEnable()
 self:SecureHookScript(CharacterFrame, "OnShow", "CharacterFrame_OnShow")
 self:SecureHookScript(CharacterFrame, "OnHide", "CharacterFrame_OnHide")
end

function DT_Durability:CharacterFrame_OnShow()
 self:RegisterEvent("UNIT_INVENTORY_CHANGED", "UpdateDurability")
 self:RegisterBucketEvent("UPDATE_INVENTORY_DURABILITY", 0.5, "UpdateDurability")
 self:UpdateDurability()

 self:RegisterEvent("UNIT_INVENTORY_CHANGED", "CheckItem")
 self:CheckItem()
end

function DT_Durability:CharacterFrame_OnHide()
 self:UnregisterEvent("UNIT_INVENTORY_CHANGED")
 self:UnregisterBucket("UPDATE_INVENTORY_DURABILITY")
end
--[[EOF]]--
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Durability_ItemLevel_Chants ]]--
---------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks ToTtip ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTToTtip()
--[[ Add Target info to Default tool tip Orginal code from http://www.curse.com/addons/wow/targetoftarget-tooltip ]]--
 local targetting = "" TARGET_PREFIX = TARGET..":|cffffffff "; DT_ToT_tip = {}
 GameTooltip:HookScript("OnUpdate", function(self, ...)
  DT_ToT_tip:AddTargetToTT()
 end)
 
 function DT_ToT_tip:AddTargetToTT()
 --[[ Exit if other tooltip mod is loaded ]]--
  if IsAddOnLoaded("DefaultTooltip") then return end
  if IsAddOnLoaded("FixehTip") then return end
  if IsAddOnLoaded("PhanxTooltip") then return end
  if IsAddOnLoaded("TipTac") then return end
  if IsAddOnLoaded("TargetofTargetTooltip") then return end
  if ( not UnitExists('mouseovertarget')) then return end
  local targetLine useExisting = false
  for i = 2, GameTooltip:NumLines() do
   targetLine = _G["GameTooltipTextLeft"..i];
   if (targetLine:GetText():find(TARGET)) then useExisting = true
      break;
   end
  end
  targetting = UnitName("mouseovertarget")
  if targetting == UnitName("player") then targetting = "<YOU>" end
  if (targetting ~= nil and targetting ~= "") then
     if useExisting then
        targetLine:SetText(string.format("%s %s |r", TARGET_PREFIX, targetting ) )
     else
        GameTooltip:AddLine( string.format("%s %s |r", TARGET_PREFIX, targetting ) )
     end
     GameTooltip:Show()
  end
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks ToTtip ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks QuestLevel ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTQuestLevel()
--[[ DTweaks_QuestLevel Orginal code modified from https://github.com/liquidbase/DuffedUIv8 ]]--
local DTweaks_QuestLevel = {}
--[[ Gossip Frame ]]--
function GossipFrameUpdate_hook()
 local buttonIndex = 1

 -- name, level, isTrivial, isDaily, isRepeatable, isLegendary, isIgnored, ... = GetGossipAvailableQuests()
 local availableQuests = {GetGossipAvailableQuests()}
 local numAvailableQuests = table.getn(availableQuests)
 for i=1, numAvailableQuests, 7 do
  local titleButton = _G["GossipTitleButton" .. buttonIndex]
  local title = "["..availableQuests[i+1].."] "..availableQuests[i]
  local isTrivial = availableQuests[i+2]
  if isTrivial then
   titleButton:SetFormattedText(TRIVIAL_QUEST_DISPLAY, title)
  else
   titleButton:SetFormattedText(NORMAL_QUEST_DISPLAY, title)
  end
  GossipResize(titleButton)
  buttonIndex = buttonIndex + 1
 end
 if numAvailableQuests > 1 then
  buttonIndex = buttonIndex + 1
 end

 -- name, level, isTrivial, isDaily, isLegendary, isIgnored, ... = GetGossipActiveQuests()
 local activeQuests = {GetGossipActiveQuests()}
 local numActiveQuests = table.getn(activeQuests)
 for i=1, numActiveQuests, 6 do
  local titleButton = _G["GossipTitleButton" .. buttonIndex]
  local title = "["..activeQuests[i+1].."] "..activeQuests[i]
  local isTrivial = activeQuests[i+2]
  if isTrivial then
   titleButton:SetFormattedText(TRIVIAL_QUEST_DISPLAY, title)
  else
   titleButton:SetFormattedText(NORMAL_QUEST_DISPLAY, title)
  end
  GossipResize(titleButton)
  buttonIndex = buttonIndex + 1
 end
end
hooksecurefunc("GossipFrameUpdate", GossipFrameUpdate_hook)

-- Hook objective tracker
function SetBlockHeader_hook()
 for i = 1, GetNumQuestWatches() do
  local questID, title, questLogIndex, numObjectives, requiredMoney, isComplete, startEvent, isAutoComplete, failureTime, timeElapsed, questType, isTask, isStory, isOnMap, hasLocalPOI = GetQuestWatchInfo(i)
  if ( not questID ) then
   break
  end
  local oldBlock = QUEST_TRACKER_MODULE:GetExistingBlock(questID)
  if oldBlock then
   local oldBlockHeight = oldBlock.height
   local oldHeight = QUEST_TRACKER_MODULE:SetStringText(oldBlock.HeaderText, title, nil, OBJECTIVE_TRACKER_COLOR["Header"])
   local newTitle = "["..select(2, GetQuestLogTitle(questLogIndex)).."] "..title
   local newHeight = QUEST_TRACKER_MODULE:SetStringText(oldBlock.HeaderText, newTitle, nil, OBJECTIVE_TRACKER_COLOR["Header"])
   oldBlock:SetHeight(oldBlockHeight + newHeight - oldHeight);
  end
 end
end
hooksecurefunc(QUEST_TRACKER_MODULE, "Update", SetBlockHeader_hook)

-- Hook quest log on map
function QuestLogQuests_hook(self, poiTable)
 local numEntries, numQuests = GetNumQuestLogEntries()
 local headerCollapsed = false
 local titleIndex = 0
 for questLogIndex = 1, numEntries do
  local title, level, suggestedGroup, isHeader, isCollapsed, isComplete, frequency, questID, startEvent, displayQuestID, isOnMap, hasLocalPOI, isTask, isBounty, isStory = GetQuestLogTitle(questLogIndex)
  if ( isHeader ) then
   headerCollapsed = isCollapsed
  elseif not isTask and (not isBounty or IsQuestComplete(questID)) and not headerCollapsed then
   titleIndex = titleIndex + 1
   local button = QuestLogQuests_GetTitleButton(titleIndex)
   local buttonText = button.Text:GetText() or ''
   local oldBlockHeight = button:GetHeight()
   local oldHeight = button.Text:GetStringHeight()
   local newTitle = "["..level.."] "..buttonText
   button.Text:SetText(newTitle)
   local newHeight = button.Text:GetStringHeight()
   button:SetHeight(oldBlockHeight + newHeight - oldHeight)
  end
 end
end
hooksecurefunc("QuestLogQuests_Update", QuestLogQuests_hook)

-- Hook quest info
function QuestInfo_hook(template, parentFrame, acceptButton, material, mapView)
 local elementsTable = template.elements
 for i = 1, #elementsTable, 3 do
  if elementsTable[i] == QuestInfo_ShowTitle then
   if QuestInfoFrame.questLog then
    local questLogIndex = GetQuestLogSelection()
    local level = select(2, GetQuestLogTitle(questLogIndex))
    local newTitle = "["..level.."] "..QuestInfoTitleHeader:GetText()
    QuestInfoTitleHeader:SetText(newTitle)
   end
  end
 end
end
hooksecurefunc("QuestInfo_Display", QuestInfo_hook)

end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks QuestLevel ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Quick_Loot ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTQuick_Loot()
 local TimeDelay = 0
 local function DTweaks_Quick_Loot()
  if GetTime() - TimeDelay >= 0.3 then
     TimeDelay = GetTime()
     if GetCVarBool("autoLootDefault") ~= IsModifiedClick("AUTOLOOTTOGGLE") then
        for i = GetNumLootItems(), 1, -1 do
            LootSlot(i)
        end
        TimeDelay = GetTime()
     end
  end
 end
 -- Event frame
 local faster = CreateFrame("Frame")
 faster:RegisterEvent("LOOT_READY")
 faster:SetScript("OnEvent", DTweaks_Quick_Loot)
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Quick_Loot ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks TinyMainbarInfo ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTTinyMainbarInfo()
--[[ Orginal Code TinyMainbarInfo by Bastian Pflieger <wb@illogical.de>
      update: December 19, 2006 (by Pseudopath for WoW version 2 compatibility)
      update: November 13, 2008 (by Dridzt for WoW 3.x/WotLK compatibility)
      update: October 03, 2010 (by Dridzt for WoW 4.x/Cataclysm compatibility)
      update: June 29, 2011 (by Dridzt for WoW 4.2/Firelands)
      update: November 20, 2011 (by Dridzt for WoW 4.3/Dragonsoul)
      update: January  2015 (by D0wntown for WOD)
              Added durability Icon, Guild Info, and updated Addon Memory Usage to exclude Blizzard Lua
              Added Direction Icon
]]--

local FORMAT_COORDS = "|TInterface\\CURSOR\\Directions.png:0|t %.1f, %.1f"
local FORMAT_NETSTATS = "%.2f KB/S"
local FORMAT_TIME_ONLINE = "%d:%02d:%02d"
local FORMAT_MEMORY_USAGE = "%.2f MB"
local FORMAT_FPS
local FORMAT_LAG = ""
local FORMAT_DURABILITY
local FORMAT_ILEVEL = "%d"
local FORMAT_ILEVEL_COLOR
local GUILD_INFO_FORMAT = " %.4s (%.4s)"

local onlineTime = 0;
local timer = 0;
local doScan, loaded;

local microButtons = {
 "CharacterMicroButton",
 "SpellbookMicroButton",
 "TalentMicroButton",
 "QuestLogMicroButton",
 "MainMenuMicroButton",
 "PVPMicroButton",
 "SocialsMicroButton",
 "GuildMicroButton",
 "GuildMicroButtonTabard",
 "LFDMicroButton",
 "HelpMicroButton",
 "AchievementMicroButton",
 "EJMicroButton",
 "RaidMicroButton",
}

if MICRO_BUTTONS and CopyTable then
 wipe(microButtons)
 microButtons = CopyTable(MICRO_BUTTONS)
end

--[[Check if we need special handling for MicroButtonPortrait, GuildMicroButtonTabard
Those are the two that have separate events modifying their alpha.
Might need to also hook GuildMicroButton_UpdateTabard() or just add it to the frame list.
]]--

local ilevelSlots = {
 (GetInventorySlotInfo("HeadSlot")),
 (GetInventorySlotInfo("NeckSlot")),
 (GetInventorySlotInfo("ShoulderSlot")),
 (GetInventorySlotInfo("BackSlot")),
 (GetInventorySlotInfo("ChestSlot")),
 (GetInventorySlotInfo("WristSlot")),
 (GetInventorySlotInfo("HandsSlot")),
 (GetInventorySlotInfo("WaistSlot")),
 (GetInventorySlotInfo("LegsSlot")),
 (GetInventorySlotInfo("FeetSlot")),
 (GetInventorySlotInfo("Finger0Slot")),
 (GetInventorySlotInfo("Finger1Slot")),
 (GetInventorySlotInfo("Trinket0Slot")),
 (GetInventorySlotInfo("Trinket1Slot")),
 (GetInventorySlotInfo("MainHandSlot")),
 (GetInventorySlotInfo("SecondaryHandSlot")),
}

function TinyMainbarInfo_Setup(enabled)
  TinyMainbarInfo_Enabled = enabled;
  if TinyMainbarInfo_Enabled then
  for i,v in ipairs(microButtons) do
   local btn = _G[v]
   if btn then btn:SetAlpha(0) end
  end
    MainMenuBarTexture2:SetAlpha(0.6);
    MainMenuBarTexture3:SetAlpha(0.6);
    TinyMainbarInfoFrame:Show();
  else
  for i,v in ipairs(microButtons) do
   local btn = _G[v]
   if btn then btn:SetAlpha(1) end
  end
    MainMenuBarTexture2:SetAlpha(1);
    MainMenuBarTexture3:SetAlpha(1);
    TinyMainbarInfoFrame:Hide();
  end
end

local function TinyMainbarInfo_UpdateMicroButtons()
  if TinyMainbarInfo_Enabled then
    TinyMainbarInfo_Setup(true);
  else
    TinyMainbarInfo_Setup(false);
  end
end

local function TinyMainbarInfo_dura()
 local minDura = 100
 for index, value in pairs(INVENTORY_ALERT_STATUS_SLOTS) do
  local cur, maxim = GetInventoryItemDurability(index)
  if cur then
   percent = (cur/maxim) * 100
   minDura = percent < minDura and percent or minDura
  end
 end
 if minDura<25 then
  FORMAT_DURABILITY = "|TInterface\\Icons\\Trade_BlackSmithing:0|t "..RED_FONT_COLOR_CODE.."%d%%"..FONT_COLOR_CODE_CLOSE
 elseif minDura<65 then
  FORMAT_DURABILITY = "|TInterface\\Icons\\Trade_BlackSmithing:0|t "..YELLOW_FONT_COLOR_CODE.."%d%%"..FONT_COLOR_CODE_CLOSE
 else
  FORMAT_DURABILITY = "|TInterface\\Icons\\Trade_BlackSmithing:0|t "..GREEN_FONT_COLOR_CODE.."%d%%"..FONT_COLOR_CODE_CLOSE
 end
 return format(FORMAT_DURABILITY,minDura)
end

local quality = {}
local function TinyMainBarInfo_iLvl()
 local avgilvl, oldilvl
 wipe(quality)
 local count, total = 0,0
 for i,v in ipairs(ilevelSlots) do
  local id = GetInventoryItemID("player",v)
  if id then
   local n,_,q,ilvl = GetItemInfo(id)
   if n then
    total = total + ilvl
    count = count + 1
    quality[q] = quality[q] and quality[q]+1 or 1
   end
  end
 end
 if total > 0 and count > 0 then
  oldilvl = total/count
 end
 local maj, num = 0,0
 if next(quality) then
  for k,v in pairs(quality) do
   num = v>num and v or num
  end
  for k,v in pairs(quality) do
   if v == num then
    maj = k
    break
   end
  end
 end
 if maj then
  FORMAT_ILEVEL_COLOR = "|c"..select(4,GetItemQualityColor(maj)).."%d"..FONT_COLOR_CODE_CLOSE
 end
 if GetAverageItemLevel then
  local avgilvleq
  avgilvl, avgilvleq = GetAverageItemLevel()
  if avgilvleq then oldilvl = avgilvleq end
 end
 if avgilvl and oldilvl then
  return format(FORMAT_ILEVEL.."("..FORMAT_ILEVEL_COLOR..")",avgilvl,oldilvl)
 elseif avgilvl then
  return format(FORMAT_ILEVEL,avgilvl)
 elseif oldilvl then
  return format(FORMAT_ILEVEL_COLOR,oldilvl)
 else
  return "?"
 end
end

local function TinyMainbarInfo_modf(num)
  return math.floor(num), num - math.floor(num);
end

local function TinyMainbarInfo_OnLoad(self)
  hooksecurefunc("UpdateMicroButtons",TinyMainbarInfo_UpdateMicroButtons);
  hooksecurefunc("GuildMicroButton_UpdateTabard",TinyMainbarInfo_UpdateMicroButtons); -- check if needed

  self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
  self:RegisterEvent("PLAYER_ENTERING_WORLD")
  self:RegisterEvent("PLAYER_MONEY")
  self:RegisterEvent("UPDATE_INVENTORY_DURABILITY")
  self:RegisterEvent("UPDATE_INVENTORY_ALERTS")
  self:RegisterEvent("PLAYER_AVG_ITEM_LEVEL_READY")
  self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
  self:RegisterEvent("PLAYER_FLAGS_CHANGED")

  TinyMainbarInfo_Setup(true);
 for i,v in ipairs(microButtons) do
  local btn = _G[v]
  if btn then
   btn:HookScript("OnEnter", function(self) TinyMainbarInfo_Setup(false) end)
   btn:HookScript("OnLeave", function(self) TinyMainbarInfo_Setup(true) end)
  end
 end
end

local function TinyMainbarInfo_OnEvent(self, event, ...)
 if event == "PLAYER_ENTERING_WORLD" then
  -- money, durability, ilvl
  self.moneyText:SetText(GetCoinTextureString(GetMoney(),10))
  self.duraText:SetText(TinyMainbarInfo_dura())
  self.ilvlText:SetText(TinyMainBarInfo_iLvl())
  self.onlineIcon:SetText(UnitIsAFK("player") and "|TInterface\\FriendsFrame\\StatusIcon-Away:0|t" or UnitIsDND("player") and "|TInterface\\FriendsFrame\\StatusIcon-DnD:0|t" or "|TInterface\\FriendsFrame\\StatusIcon-Online:0|t")
  self:RegisterEvent("BAG_UPDATE")
 elseif event == "UPDATE_INVENTORY_DURABILITY" or event == "UPDATE_INVENTORY_ALERTS" then
  -- durability
  self.duraText:SetText(TinyMainbarInfo_dura())
 elseif event == "PLAYER_AVG_ITEM_LEVEL_READY" or event == "PLAYER_EQUIPMENT_CHANGED" or event == "BAG_UPDATE" then
  -- average ilvl
  doScan = GetTime() -- done in OnUpdate2 when there's 0.5 sec from last request passed.
 elseif event == "PLAYER_MONEY" then
  -- money
  self.moneyText:SetText(GetCoinTextureString(GetMoney(),10))
 elseif event == "PLAYER_FLAGS_CHANGED" then
  -- online time icon (on,away,dnd)
  self.onlineIcon:SetText(UnitIsAFK("player") and "|TInterface\\FriendsFrame\\StatusIcon-Away:0|t" or UnitIsDND("player") and "|TInterface\\FriendsFrame\\StatusIcon-DnD:0|t" or "|TInterface\\FriendsFrame\\StatusIcon-Online:0|t")
 elseif event == "ZONE_CHANGED_NEW_AREA" then
   SetMapToCurrentZone();
  end
end

local function TinyMainbarInfo_OnUpdate(self, elapsed)
  onlineTime = onlineTime + elapsed;
  timer = timer + elapsed;
end

local function TinyMainbarInfo_OnUpdate2(self, elapsed)
 if doScan and GetTime()>(doScan+0.5) then
  self.ilvlText:SetText(TinyMainBarInfo_iLvl())
   doScan = nil
  end
  if timer > 1 then
    isInstance, instanceType = IsInInstance()
    if (IsInInstance()) then
       self.coordText:SetText(string.format(FORMAT_COORDS, 0, 0));
    else
       local x, y = GetPlayerMapPosition("player");
       self.coordText:SetText(string.format(FORMAT_COORDS, x * 100, y * 100));
    end
    -- Update network flow
    local kbin, kbout, mlatency, wlatency = GetNetStats();
    self.netText:SetText(string.format(FORMAT_NETSTATS, kbin + kbout));

    if mlatency >= 600 then
      FORMAT_LAG = RED_FONT_COLOR_CODE.."(%d)"..FONT_COLOR_CODE_CLOSE;
    elseif mlatency >= 300 then
      FORMAT_LAG = LIGHTYELLOW_FONT_COLOR_CODE.."(%d)"..FONT_COLOR_CODE_CLOSE;
    else
      FORMAT_LAG = GREEN_FONT_COLOR_CODE.."(%d)"..FONT_COLOR_CODE_CLOSE;
    end
    if wlatency >= 600 then
      FORMAT_LAG = FORMAT_LAG..RED_FONT_COLOR_CODE.."%dms"..FONT_COLOR_CODE_CLOSE;
    elseif wlatency >= 300 then
      FORMAT_LAG = FORMAT_LAG..LIGHTYELLOW_FONT_COLOR_CODE.."%dms"..FONT_COLOR_CODE_CLOSE;
    else
      FORMAT_LAG = FORMAT_LAG..GREEN_FONT_COLOR_CODE.."%dms"..FONT_COLOR_CODE_CLOSE;
    end
    self.latText:SetText(string.format(FORMAT_LAG, mlatency, wlatency));

    if (IsInGuild()) then
       GuildRoster()
       -- Guild members online if in Guild
       local numTotal, numOnlineMaxLevel, numOnline = GetNumGuildMembers();
       self.onlineText:SetText(string.format(GUILD_INFO_FORMAT, numOnline, numTotal));
    else
    -- Update time played this session
       local hours, frac = TinyMainbarInfo_modf(onlineTime / 60 / 60);
       local minutes, frac = TinyMainbarInfo_modf(frac * 60);
       local seconds =   TinyMainbarInfo_modf(frac * 60);
       self.onlineText:SetText(string.format(FORMAT_TIME_ONLINE, hours, minutes, seconds));
    end

    -- Update interface memory usage
    -- Updated to only grep Additional Addon Memory Usage exclude the default Blizzard Addons.
    local meg = 0
    UpdateAddOnMemoryUsage()
    for i = 1, GetNumAddOns() do
      meg = meg + (GetAddOnMemoryUsage(i)/1024)
    end
    self.memText:SetText(string.format(FORMAT_MEMORY_USAGE, meg));

    -- Update fps
    local fps = GetFramerate()
    if fps < 15 then
      FORMAT_FPS = RED_FONT_COLOR_CODE.."%.1f FPS"..FONT_COLOR_CODE_CLOSE
    elseif fps < 30 then
      FORMAT_FPS = YELLOW_FONT_COLOR_CODE.."%.1f FPS"..FONT_COLOR_CODE_CLOSE
    else
      FORMAT_FPS = "%.1f FPS"
    end
    self.fpsText:SetText(string.format(FORMAT_FPS, fps));

    timer = 0;
  end
end

do
 local timeframe = CreateFrame("Frame")
 timeframe:SetScript("OnUpdate", TinyMainbarInfo_OnUpdate)

 local f = CreateFrame("Frame","TinyMainbarInfoFrame",MainMenuBarArtFrame)
 f:SetFrameLevel(f:GetParent():GetFrameLevel()+1)
 f:SetScript("OnEvent", TinyMainbarInfo_OnEvent)
 f:SetScript("OnUpdate", TinyMainbarInfo_OnUpdate2)

 local onlineIcon = f:CreateFontString(nil,"OVERLAY") -- left column
 local onlineText = f:CreateFontString(nil,"OVERLAY")
 onlineIcon:SetPoint("TOPLEFT",MainMenuBarArtFrame,"TOPLEFT", 550,-14 )
 onlineText:SetPoint("TOPLEFT",onlineIcon,"TOPRIGHT",0,0)
 f.onlineText = onlineText
 f.onlineText:SetFontObject("GameFontNormalSmall")
 f.onlineText:SetTextColor(1,1,1)
 f.onlineIcon = onlineIcon
 f.onlineIcon:SetFontObject("GameFontNormalSmall")
 f.onlineIcon:SetTextColor(1,1,1)

 local coordText = f:CreateFontString(nil,"OVERLAY")
 coordText:SetPoint("TOPLEFT",onlineIcon,"BOTTOMLEFT",0,-3)
 f.coordText = coordText
 f.coordText:SetFontObject("GameFontNormalSmall") -- fontsize 10
 f.coordText:SetTextColor(1,1,1)

 local latText = f:CreateFontString(nil,"OVERLAY")
 latText:SetPoint("TOPLEFT",coordText,"BOTTOMLEFT",0,-3)
 f.latText = latText
 f.latText:SetFontObject("GameFontNormalSmall")
 f.latText:SetTextColor(1,1,1)

 local moneyText = f:CreateFontString(nil,"OVERLAY") -- middle column
 moneyText:SetPoint("TOPLEFT",onlineIcon,"TOPRIGHT",90,0)
 f.moneyText = moneyText
 f.moneyText:SetFontObject("GameFontNormalSmall")
 f.moneyText:SetTextColor(1,1,1)

 local duraText = f:CreateFontString(nil,"OVERLAY")
 duraText:SetPoint("TOP",moneyText,"BOTTOM",-10,-3)
 f.duraText = duraText
 f.duraText:SetFontObject("GameFontNormalSmall")
 f.duraText:SetTextColor(1,1,1)

 local ilvlText = f:CreateFontString(nil,"OVERLAY")
 ilvlText:SetPoint("TOP",duraText,"BOTTOM",0,-3)
 f.ilvlText = ilvlText
 f.ilvlText:SetFontObject("GameFontNormalSmall")
 f.ilvlText:SetTextColor(1,1,1)

 local fpsText = f:CreateFontString(nil,"OVERLAY") -- right column
 fpsText:SetPoint("TOPLEFT",moneyText,"TOPRIGHT",45,0)
 f.fpsText = fpsText
 f.fpsText:SetFontObject("GameFontNormalSmall")
 f.fpsText:SetTextColor(1,1,1)

 local memText = f:CreateFontString(nil,"OVERLAY")
 memText:SetPoint("TOPRIGHT",fpsText,"BOTTOMRIGHT",0,-3)
 f.memText = memText
 f.memText:SetFontObject("GameFontNormalSmall")
 f.memText:SetTextColor(1,1,1)

 local netText = f:CreateFontString(nil,"OVERLAY")
 netText:SetPoint("TOPRIGHT",memText,"BOTTOMRIGHT",0,-3)
 f.netText = netText
 f.netText:SetFontObject("GameFontNormalSmall")
 f.netText:SetTextColor(1,1,1)

 TinyMainbarInfo_OnLoad(f)
end
--[[ EOF ]]--

end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks TinyMainbarInfo ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks UnDress ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTUnDress()
 --[[ Remove Tabard Buttons ]]--
 local notabardButton1 = CreateFrame('Button', 'notabardButton1', DressUpFrame, 'UIPanelButtonTemplate')
 notabardButton1Text:SetText("No-Tabard") ; notabardButton1:SetSize(80, 22) ; notabardButton1:SetPoint('RIGHT', 'DressUpFrameResetButton', 'LEFT') ; notabardButton1:SetFrameStrata('HIGH')

 notabardButton1:SetScript('OnClick', function() DressUpModel:UndressSlot(19) end)

 local notabardButton2 = CreateFrame('Button', 'notabardButton2', SideDressUpFrame, 'UIPanelButtonTemplate')
 notabardButton2Text:SetText("No-Tabard") ; notabardButton2:SetSize(80, 22) ; notabardButton2:SetPoint('TOP', 'SideDressUpModelResetButton', 'BOTTOMLEFT') ; notabardButton2:SetFrameStrata('HIGH')

 notabardButton2:SetScript('OnClick', function() SideDressUpModel:UndressSlot(19) end)

 --[[ Un-Dress Buttons ]]--
 local undressBotton1 = CreateFrame('Button', 'undressBotton1', DressUpFrame, 'UIPanelButtonTemplate')
 undressBotton1Text:SetText("Un-Dress") ; undressBotton1:SetSize(80, 22) ; undressBotton1:SetPoint('RIGHT', 'notabardButton1', 'LEFT') ; undressBotton1:SetFrameStrata('HIGH')

 undressBotton1:SetScript('OnClick', function() DressUpFrameResetButton:Click() for i = 1, 19 do DressUpModel:UndressSlot(i) end end)

 local undressButton2 = CreateFrame('Button', 'undressButton2', SideDressUpFrame, 'UIPanelButtonTemplate')
 undressButton2Text:SetText("Un-Dress") ; undressButton2:SetSize(80, 22) ; undressButton2:SetPoint('TOP', 'SideDressUpModelResetButton', 'BOTTOMRIGHT') ; undressButton2:SetFrameStrata('HIGH')

 undressButton2:SetScript('OnClick', function() SideDressUpModelResetButton:Click() for i = 1, 19 do SideDressUpModel:UndressSlot(i) end end)
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks UnDress ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks ScreenGrid ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:DTScreenGrid()
 --[[
     I put code here since it has not been updated on curse since 9/18/2012 I find it useful and wanted to keep it avail.
     Orginal Code: http://www.curse.com/addons/wow/screen-grid Author: Centella of Medivh-US

     Description: Creates a custom-sized grid on your screen made of black lines.
                  The grid will cover the entire screen, allowing any movable UI elements to be arranged and aligned.
                  Moving UI elements may require an additional, non-included addon.
     Usage:
            /sg x "x should be the number of lines to be displayed."
                  "To hide completely, use /sg "no args".
     Note:
            At a low number of lines (less than 16 or so), boxes may be cut off due to individual screen resolution.
            At a high number of lines (256+), the screen will start to become unreadable.
            I suggest 32-64 for larger elements, and up to 128 for fine-tuning.
     Feb 2015 D0wntown included with DTweaks modules
 ]]--
 local bs = 0
 local CSG = CreateFrame('Frame', nil, UIParent)
 local CSG_bs
 SLASH_SCREENGRID1 = "/screengrid"
 SLASH_SCREENGRID2 = "/sg"
 SlashCmdList["SCREENGRID"] = function(msg)
    if msg == '' then
        bs = 0
    else
        bs = (math.ceil((tonumber(msg) or bs) / 4) * 4)
        if bs > 512 then
            bs = 512
        end
    end
    if CSG_bs ~= bs then
        CSG:Hide(self)
        CSG_doDraw(self)
        CSG:Show(self)
    end
 end

 function CSG_doDraw(self)
    CSG_bs = bs
    CSG = CreateFrame('Frame', nil, UIParent)
    CSG:SetAllPoints(UIParent)
    CSG:SetFrameStrata('BACKGROUND')
    CSG:SetFrameLevel(0)
    local w = GetScreenWidth()
    local r = w/GetScreenHeight()
    local h = GetScreenHeight()
    local m = UIParent:GetEffectiveScale()
    local wI = w/bs
    local hI = h/(bs/r)
    if bs > 0 then
        for i = 0, bs do
            local line = CSG:CreateLine(nil, 'BACKGROUND')
            line:SetStartPoint("TOPLEFT", i*wI*m, 0)
            line:SetEndPoint("BOTTOMLEFT", i*wI*m, 0)
            line:SetColorTexture(0, 0, 0, 0.75)
            line:SetThickness(1)
        end
        for i = 0, math.floor(bs/r) do
            local line = CSG:CreateLine(nil, 'BACKGROUND')
            line:SetStartPoint("TOPLEFT", 0, -i*hI*m)
            line:SetEndPoint("TOPRIGHT", 0, -i*hI*m)
            line:SetColorTexture(0, 0, 0, 0.75)
            line:SetThickness(1)
        end
    end
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks ScreenGrid ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Player_Target_Mover ]]--
---------------------------------------------------------------------------------------------------------------------------------
function addon:dtpfSlashCommands(input)
 local x, y = self:GetArgs(input, 2, 1, input)
 if x == "reset" then 
    PlayerFrame:ClearAllPoints()
    PlayerFrame:SetPoint("TOPRIGHT", Screen, "CENTER", -587, 446)
    PlayerFrame:SetUserPlaced(true)
    TargetFrame:ClearAllPoints()
    TargetFrame:SetPoint("TOPLEFT", Screen, "CENTER", -550, 446)
    TargetFrame:SetUserPlaced(true)
 else
   if x ~= nil and y ~= nil then
      if x ~= "" and y ~= "" then
         PlayerFrame:ClearAllPoints()
         PlayerFrame:SetPoint("TOPRIGHT", Screen, "CENTER", -x, y)
         PlayerFrame:SetUserPlaced(true)
         TargetFrame:ClearAllPoints()
         TargetFrame:SetPoint("TOPLEFT", Screen, "CENTER", x, y)
         TargetFrame:SetUserPlaced(true)
      end
   else
         --[[ Print usage ]]--
         print("Syntax:")
         print(" |cFF00FFFF/dtpf (reset) <x> <y>|r")
         print("    dtpf = player and target frame")
         print("       x = space between the player and target frames from center")
         print("       y = vertical placement of player and target frames from center")
         print("       reset = Sets player and target frames back to Blizzard default")
         print("Examples:")
         print(" |cFF00FFFF/dtpf 0 0|r      (Moves frames to center of screen no space between)")
         print(" |cFF00FFFF/dtpf 125 -175|r (Moves frames bottom center above Action bar with space between them)")
         print(" |cFF00FFFF/dtpf reset|r    (Moves frames top left blizzard default)")
   end
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Player_Target_Mover ]]--
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks Default Bag mover and scaler ]]-- 
---------------------------------------------------------------------------------------------------------------------------------
function addon:DT_Bag_Mover()
 local function SavePosition(frame)
  local id = frame:GetID()
  local scale = frame:GetScale()
  local cx, cy = frame:GetCenter()
        cx, cy = cx * scale, cy * scale
  local x, y, hpoint, vpoint
  local width, height = UIParent:GetWidth(), UIParent:GetHeight()
  if cx > (width / 2) then
     hpoint = "RIGHT"
     x = (frame:GetRight() * scale) - width
  else
     hpoint = "LEFT"
     x = frame:GetLeft() * scale
  end
  if cy > (height / 2) then
     vpoint = "TOP"
     y = (frame:GetTop() * scale) - height
  else
     vpoint = "BOTTOM"
     y = frame:GetBottom() * scale
  end
  local info = self.db.char.bagmover[id] or {}
        self.db.char.bagmover[id] = info
        info.point = vpoint..hpoint
        info.x = x
        info.y = y
  frame:ClearAllPoints()
  frame:SetPoint(info.point, floor(x / scale + 0.5), floor(y / scale + 0.5))
 end
 
 local function RestorePosition(frame)
  local id = frame:GetID()
  local info =  self.db.char.bagmover[id]
  if not info then
     return SavePosition(frame)
  end
  local s = info.scale or 1
  frame:ClearAllPoints()
  frame:SetPoint(info.point, info.x / s, info.y / s)
 end

 local function SetScale(frame, scale)
  local id = frame:GetID()
  local info =  self.db.char.bagmover[id] or {}
   self.db.char.bagmover[id] = info
  info.scale = scale
  frame:SetScale(scale)
 
  if info.point then
     RestorePosition(frame)
  end
 end
 
 local function RestoreAllPositions()
  for i = 1, NUM_CONTAINER_FRAMES do
   local frame = _G["ContainerFrame"..i]
   if frame:IsShown() then
      local id = frame:GetID()
      if id < 100 then
         local info =  self.db.char.bagmover[id]
         if info and info.point then
            SetScale(frame, info.scale or 1)
         else
            SavePosition(frame)
         end
      end
   end
  end
 end
 
 local function OnMouseDown(title)
  if IsAltKeyDown() then
     local frame = title:GetParent()
     frame:StartMoving()
     frame.__isMoving = true
     title:GetScript("OnLeave")(title)
  end
 end
 
 local function OnMouseUp(title)
  local frame = title:GetParent()
  if frame.__isMoving then
     frame:StopMovingOrSizing()
     frame:SetUserPlaced(false)
     frame.__isMoving = nil
     SavePosition(frame)
     title:GetScript("OnEnter")(title)
  end
 end
 
 local function OnHide(title)
  local frame = title:GetParent()
  if frame.__isMoving then
     frame:StopMovingOrSizing()
     frame.__isMoving = nil
  end
 end
 
 local function OnClick(title, b, ...)
  if not IsAltKeyDown() then
     title.__onClick(title, b, ...)
  end
 end

 local function OnMouseWheel(title, delta)
  if IsControlKeyDown() then
     local frame = title:GetParent()
     local scale = frame:GetScale()
     if delta > 0 then
        scale = min(scale + 0.05, 2)
     elseif delta < 0 then
        scale = max(scale - 0.05, 0.5)
     end
     SetScale(frame, floor(scale * 100 + 0.5) / 100)
  end
 end
 
 local function OnEnter(portrait)
  GameTooltip:AddLine("<Alt-Drag title bar to move this bag>", 0, 1, 0)
  GameTooltip:AddLine("<Ctrl-MouseWheel title bar to scale this bag>", 0, 1, 0)
  GameTooltip:Show()
 
  local frame = portrait:GetParent()
  if frame:GetLeft() < GameTooltip:GetWidth() then
     GameTooltip:ClearAllPoints()
     GameTooltip:SetPoint("BOTTOMLEFT", frame, "TOPRIGHT")
  end
 end
 
 ------------------------------------------------------------------------
 
 local DTweaks_Bags = CreateFrame("Frame")
 DTweaks_Bags:RegisterEvent("BANKFRAME_OPENED")
 DTweaks_Bags:RegisterEvent("PLAYER_LOGIN")
 DTweaks_Bags:SetScript("OnEvent", function(self, event)
 
  if event == "BANKFRAME_OPENED" then
     return ToggleAllBags()
  end
 
  self:UnregisterEvent("PLAYER_LOGIN")
 
  for i = 1, NUM_CONTAINER_FRAMES do
   local frame = _G["ContainerFrame"..i]
   frame:SetMovable(true)
 
   local title = frame.ClickableTitleFrame
   title:SetScript("OnMouseDown", OnMouseDown)
   title:SetScript("OnMouseUp", OnMouseUp)
   title:SetScript("OnHide", OnHide)
 
   title.__onClick = title:GetScript("OnClick")
   title:SetScript("OnClick", OnClick)
 
   title:EnableMouseWheel(true)
   title:SetScript("OnMouseWheel", OnMouseWheel)
 
   local portrait = frame.PortraitButton
   portrait:HookScript("OnEnter", OnEnter)
  end
 
  hooksecurefunc("UpdateContainerFrameAnchors", RestoreAllPositions)
 end)
 
 ------------------------------------------------------------------------
 
 hooksecurefunc("ContainerFrame_GenerateFrame", function(frame, size, id)
  if IsAddOnLoaded("CanIMogIt") then
     _G[frame:GetName().."Name"]:SetTextColor(1, 1, 1)
  else
     if id and id > 0 and ENABLE_COLORBLIND_MODE == "0" then
        local link = GetInventoryItemLink("player", ContainerIDToInventoryID(id))
        local _, _, quality = GetItemInfo(link)
        local r, g, b = GetItemQualityColor(quality)
        _G[frame:GetName().."Name"]:SetTextColor(r, g, b)
     else
        _G[frame:GetName().."Name"]:SetTextColor(1, 1, 1)
     end
  end
 end)

 ------------------------------------------------------------------------
 
 local YES = "|cff7fff7f"..YES.."|r"
 local NO = "|cffff9f9f"..NO.."|r"
 
 self:RegisterChatCommand("dtbags", "HandleSlashCommands")
 function addon:HandleSlashCommands(input)
  local arg1, arg2 = self:GetArgs(input, 2, 1, input)
  if arg1 == 'reset' then
      wipe(self.db.char.bagmover)
      for i = 1, NUM_CONTAINER_FRAMES do
          local frame = _G["ContainerFrame"..i]
          frame:SetScale(1)
          frame:SetUserPlaced(false)
          frame:ClearAllPoints()
      end
      print("|cffffcc00DTweaks_Bags:|r", "Now reset to Blizzard defaults")
      return UpdateContainerFrameAnchors()
  end
  if arg1 == "scale" then
     local scale = tonumber(arg2)
     if scale and scale >= 0.5 and scale <= 2 then
        for i = 1, NUM_CONTAINER_FRAMES do
            local frame = _G["ContainerFrame"..i]
            SetScale(frame, scale)
        end
     else
        print("|cffffcc00/dtbags scale #|r", "Scale must be between 0.5 and 2!")
      end
      return
  end
  if arg1 == nil then
  self:Print("|cFF00FFFF/dtbags|r Examples:\n|cFF00FFFF/dtbags reset|r (Reset the position and scale of all bags)\n|cFF00FFFF/dtbags scale #|r (Change the scale of all bags \"allowed: 0.5-2\")")
  end
 end

end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks Default Bag mover and scaler ]]-- 
---------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------------------------------------------------
--[[ DTweaks InGame Options MENUs ]]-- 
---------------------------------------------------------------------------------------------------------------------------------
function addon:PopulateOptions()
 if not options then
    options = {
    order = 1,
    type  = "group",
    name  = "DTweaks v"..Version,
     args  = {
      general = {
       order   = 1,
       type    = "group",
       name    = "Configuration",
       args    = {
       divider1 = {
       order   = 1,
       type    = "description",
       name    = "",
       },
       Slash = {
       order   = 2,
       type    = "toggle",
       name    = "Slash Commands",
       desc    = "Enable extra slash commands:\n /rl for reload ui,\n /rc for readycheck,\n /cr for check role,\n /rh for hide default raid windows,\n /rs for show default raid window,\n /rm for random mount,\n /lg for leave group,\n /tout to teleport out of LFG/LFR,\n /tin to teleport to LFG/LFR.",
       get     = function() return addon.db.char.Slash end,
       set     = function() self.db.char.Slash = not self.db.char.Slash end,
       },
       Remove_Griffins = {
       order   = 3,
       type    = "toggle",
       name    = "Hide Griffins",
       desc    = "Hide Action Bar End Caps.",
       get     = function() return addon.db.char.Remove_Griffins end,
       set     = function() self.db.char.Remove_Griffins = not self.db.char.Remove_Griffins end,
       },
       AutoTypeDelete = {
       order   = 4,
       type    = "toggle",
       name    = "Auto Type Delete",
       desc    = "Enable auto typing DELETE in the popup window to destroy items.",
       get     = function() return addon.db.char.AutoTypeDelete end,
       set     = function() self.db.char.AutoTypeDelete = not self.db.char.AutoTypeDelete end,
       },
       AutoRepair = {
       order   = 5,
       type    = "toggle",
       name    = "Auto Repair",
       desc    = "Auto repair @ repair merchant with guild funds before personal funds if guild repair is an option.",
       get     = function() return addon.db.char.AutoRepair end,
       set     = function() self.db.char.AutoRepair = not self.db.char.AutoRepair end,
       },
       Chat = {
       order   = 6,
       type    = "toggle",
       name    = "Chat Mods",
       desc    = "URL Copy & Chat Copy, More Font sizes, Scroll to Top/Bot with shift key/Mouse wheel, Alt click player name to invite to group,\nShort channel names:\nGuild = G, Officer = O, Raid = R, RaidWarning = RW, RaidLeader = RL, Party = P, PartyLeader = PL, PartyGuide = PG, BG/Instance = I, BGLeader/InstanceLeader = IL, WhisperSent/BattleNetWhisperSent = to, WhisperRecived/BattleNetWhisperRecived = from, General = GEN, Trade = T, Looking For Group = LFG, LocalDefence = LD, Remove need to hold [alt] key down to move left or right with arrow keys in chat editbox. Remove chat box buttons, auto fade, disable tab blink, move Edit box to top, and allow you to move chat box to edge of screen.",
       get     = function() return addon.db.char.Chat end,
       set     = function() self.db.char.Chat = not self.db.char.Chat end,
       },
       MaxCamera = {
       order   = 7,
       type    = "toggle",
       name    = "Max Camera Zoom",
       desc    = "Checked sets Camera to max zoom unchecked sets back to default.",
       get     = function() return addon.db.char.Zoomed end,
       set     = function() self.db.char.Zoomed = not self.db.char.Zoomed end,
       },
       MiniMap = {
       order   = 8,
       type    = "toggle",
       name    = "Mini Map Mods",
       desc    = "Hide Mini-Map Zoom Buttons, Enable Mini-Map Zoom Mouse Scrolling",
       get     = function() return addon.db.char.MiniMap end,
       set     = function() self.db.char.MiniMap = not self.db.char.MiniMap end,
       },
       Map_Cords = {
       order   = 9,
       type    = "toggle",
       name    = "Map Cordinates",
       desc    = "Adds map coordinates to world map for player and cursor position.",
       get     = function() return addon.db.char.MapCords end,
       set     = function() self.db.char.MapCords = not self.db.char.MapCords end,
       },
       MicroButtonTips = {
       order   = 10,
       type    = "toggle",
       name    = "Micro Button Tooltips",
       desc    = "Display Tool-tip info on micro buttons Character/SpellBook/Guild: Character Tool-tip - Order Resources, Ancient Mana, Sightless Eye, Curious Coin, Lingering Soul Fragment, Timeworn Artifact, Apexis Crystal, Artifact Fragment, Dingy Iron Coins, Garrison Resources, Oil, Seal of Inevitable Fate, Seal of Tempered Fate, Valor, and Drowned Mana. SpellBook Tool-tip - Professions and current levels including bonus. Guild Tool-tip - Guild name and realm, members online, level and location, sorted by name by default; with shift key pressed sort=level ; with alt key pressed sort=zone",
       get     = function() return addon.db.char.Micro_Button_Tips end,
       set     = function() self.db.char.Micro_Button_Tips = not self.db.char.Micro_Button_Tips end,
       },
       AutoSelectQuestReward = {
       order   = 11,
       type    = "toggle",
       name    = "Auto Select QuestReward",
       desc    = "Auto select highest vendor value quest reward, You can still choose different reward.",
       get     = function() return addon.db.char.Auto_Select_QuestReward end,
       set     = function() self.db.char.Auto_Select_QuestReward = not self.db.char.Auto_Select_QuestReward end,
       },
       AutoRepSwitch = {
       order   = 12,
       type    = "toggle",
       name    = "Auto Rep Switch",
       desc    = "Auto Switch Reputation tracking bar, Unless Reputation is set to Inactive.",
       get     = function() return addon.db.char.AutoRepSwitch end,
       set     = function() self.db.char.AutoRepSwitch = not self.db.char.AutoRepSwitch end,
       },
       CastBar_Timer = {
       order   = 13,
       type    = "toggle",
       name    = "CastBar Timer",
       desc    = "Add castbar timer to bottom of default castbar.",
       get     = function() return addon.db.char.CastBar_Timer end,
       set     = function() self.db.char.CastBar_Timer = not self.db.char.CastBar_Timer end,
       },
       Durability_ItemLevel_Chants = {
       order   = 14,
       type    = "toggle",
       name    = "Durability ItemLevel Chants",
       desc    = "Display Durability percentage, ItemLevel\nand missing Enchants or Gems on character frame.",
       get     = function() return addon.db.char.Durability_ItemLevel_Chants end,
       set     = function() self.db.char.Durability_ItemLevel_Chants = not self.db.char.Durability_ItemLevel_Chants end,
       },
       Enlarge_Player_Target_Frame = {
       order   = 15,
       type    = "toggle",
       name    = "Enlarge Player/Target Frame",
       desc    = "Increase Default Player/Target Unit Frame 20%",
       get     = function() return addon.db.char.Enlarge_Player_Target_Frame end,
       set     = function() self.db.char.Enlarge_Player_Target_Frame = not self.db.char.Enlarge_Player_Target_Frame end,
       },
       Focus_CastBar_Mover = {
       order   = 16,
       type    = "toggle",
       name    = "Focus CastBar On Top",
       desc    = "Move the cast bar above the focus frame instead of under the auras.",
       get     = function() return addon.db.char.Focus_CastBar_Mover end,
       set     = function() self.db.char.Focus_CastBar_Mover = not self.db.char.Focus_CastBar_Mover end,
       },
       Target_CastBar_Mover = {
       order   = 17,
       type    = "toggle",
       name    = "Target CastBar On Top",
       desc    = "Move the cast bar above the target frame instead of under the auras.",
       get     = function() return addon.db.char.Target_CastBar_Mover end,
       set     = function() self.db.char.Target_CastBar_Mover = not self.db.char.Target_CastBar_Mover end,
       },
       ToTtip = {
       order   = 18,
       type    = "toggle",
       name    = "Target of Target Tooltip ",
       desc    = "Add Target name to default tool.",
       get     = function() return addon.db.char.ToTtip end,
       set     = function() self.db.char.ToTtip = not self.db.char.ToTtip end,
       },
       Fonts = {
       order   = 19,
       type    = "toggle",
       name    = "DTweaks Font",
       desc    = "Enables a nice default font for damage, unit frames, and standard text for your UI.",
       get     = function() return addon.db.char.Fonts end,
       set     = function() self.db.char.Fonts = not self.db.char.Fonts end,
       },
       Player_Damage_Spam = {
       order   = 20,
       type    = "toggle",
       name    = "Player Damage Spam",
       desc    = "Disables healing/damage spam on player frame.",
       get     = function() return addon.db.char.Player_Damage_Spam end,
       set     = function() self.db.char.Player_Damage_Spam = not self.db.char.Player_Damage_Spam end,
       },
       Pet_Damage_Spam = {
       order   = 21,
       type    = "toggle",
       name    = "Pet Damage Spam",
       desc    = "Disable healing/damage spam on pet frame.",
       get     = function() return addon.db.char.Pet_Damage_Spam end,
       set     = function() self.db.char.Pet_Damage_Spam = not self.db.char.Pet_Damage_Spam end,
       },
       QuestLevel = {
       order   = 22,
       type    = "toggle",
       name    = "Quest Level",
       desc    = "Displays Quest Level on Default Quest Log, Quest Map Log, and Quest Tracker Frames.",
       get     = function() return addon.db.char.QuestLevel end,
       set     = function() self.db.char.QuestLevel = not self.db.char.QuestLevel end,
       },
       Quick_Loot = {
       order   = 23,
       type    = "toggle",
       name    = "Quick Loot",
       desc    = "Enables Quicker looting by skipping loot window display.",
       get     = function() return addon.db.char.Quick_Loot end,
       set     = function() self.db.char.Quick_Loot = not self.db.char.Quick_Loot end,
       },
       TinyMainbarInfo = {
       order   = 24,
       type    = "toggle",
       name    = "Tiny MainBar Info",
       desc    = "Adds overlay on micro buttons and shows original micro buttons on mouse over. Player status indicator Icon (away, busy, available) Guild Members Online/Total Members , Money , FPS Player Coordinates, Durability, Memory Used by (addons) Latency, Blizzard Average Item Level / (equipped only itemlevel color coded by quality), Total Bandwidth used by the client (up+down).",
       get     = function() return addon.db.char.TinyMainbarInfo end,
       set     = function() self.db.char.TinyMainbarInfo = not self.db.char.TinyMainbarInfo end,
       },
       UnDress = {
       order   = 25,
       type    = "toggle",
       name    = "UnDress Buttons",
       desc    = "Adds Un-Dress and No-Tabard buttons to dress up frames.",
       get     = function() return addon.db.char.UnDress end,
       set     = function() self.db.char.UnDress = not self.db.char.UnDress end,
       },
       Reverse_Sort = {
       order   = 26,
       type    = "toggle",
       name    = "Reverse Sort Bags",
       desc    = "Sets Reverse sort on bags, Leave unchecked to use default sort",
       get     = function() return addon.db.char.Reverse_Sort_Bags end,
       set     = function() self.db.char.Reverse_Sort_Bags = not self.db.char.Reverse_Sort_Bags end,
       },
       ScreenGrid = {
       order   = 27,
       type    = "toggle",
       name    = "Screen Grid",
       desc    = "Adds /sg (#) slash command to add screen grid lines.\n Example: /sg 64 \"adds 64 screen grid lines.\" /sg \"removes grid lines\".",
       get     = function() return addon.db.char.ScreenGrid end,
       set     = function() self.db.char.ScreenGrid = not self.db.char.ScreenGrid end,
       },
       Player_Target_Mover = {
       order   = 28,
       type    = "toggle",
       name    = "Player Target Mover",
       desc    = "Adds /dtpf slash command to position your player/target frames to a position relative to the middle of the screen. Run /dtpf ? for syntax.",
       get     = function() return addon.db.char.Player_Target_Mover end,
       set     = function() self.db.char.Player_Target_Mover = not self.db.char.Player_Target_Mover end,
       },
       HideTalkingHead = {
       order   = 30,
       type    = "toggle",
       name    = "Hide Talking Heads",
       desc    = "Hides the default Talking Head frame.",
       get     = function() return addon.db.char.HideTalkingHead end,
       set     = function() self.db.char.HideTalkingHead = not self.db.char.HideTalkingHead end,
       },
       BUFFs_16 = {
       order   = 31,
       type    = "toggle",
       name    = "Show 16 Buffs",
       desc    = "Allows for 16 Buffs instead of the default 8 on default interface top right corner.",
       get     = function() return addon.db.char.Buffs_16 end,
       set     = function() self.db.char.Buffs_16 = not self.db.char.Buffs_16 end,
       },
       Bag_Mover = {
       order   = 32,
       type    = "toggle",
       name    = "Bag Mover/Scaler",
       desc    = "Allows you to move and scale the default blizzard bags.",
       get     = function() return addon.db.char.DTweaks_Bag_Mover end,
       set     = function() self.db.char.DTweaks_Bag_Mover = not self.db.char.DTweaks_Bag_Mover end,
       },
       Loot_Hist = {
       order   = 33,
       type    = "toggle",
       name    = "Auto Loot History Window",
       desc    = "Allows you to prevent the Loot History window from poping up in party and raids.\n/loot still toggles show/hide.",
       get     = function() return addon.db.char.noauto_loot_hist end,
       set     = function() self.db.char.noauto_loot_hist = not self.db.char.noauto_loot_hist end,
       },
       divider2 = {
       order   = 40,
       type    = "description",
       name    = "",
       },
       header1 = {
       order   = 41,
       type    = "header",
       name    = "Enable Junkseller & Manage Extra JunkList Items.",
       },
       note2   = {
       order   = 42,
       type    = "description",
       name    = "Drag and drop item, or shift click item into the add/remove box, to modify Junk Sell list.",
       },
       JunkSeller = {
       order   = 43,
       type    = "toggle",
       name    = "Automatically Sell Junk",
       desc    = "Sell junk when merchant window is opened. Note: only max of 12 different items will be sold at each vendor interaction. Incase you need to buy back an Item\nOptionally you can create a junklist for additional items you want to always sell.",
       get     = function() return addon.db.char.JunkSeller end,
       set     = function() self.db.char.JunkSeller = not self.db.char.JunkSeller end,
       },
       C_JunkList = {
       order   = 44,
       type    = "toggle",
       name    = "Character based JunkList.",
       desc    = "If unchecked the JunkList is Global for all characters.",
       get     = function() return addon.db.char.C_JunkList end,
       set     = function() self.db.char.C_JunkList = not self.db.char.C_JunkList end,
       },
       divider3 = {
       order   = 45,
       type    = "description",
       name    = "",
       },
       add = {
       order   = 46,
       type    = "input",
       name    = "Add item"..':',
       usage   = "Drag and Drop Item from bag or Shift click <Item Link> here",
       get     = false,
       set     = function(info, v) addon:Add(v) end,
       },
       rem = {
       order   = 47,
       type    = "input",
       name    = "Remove item"..':',
       usage   = "Drag and Drop Item from bag or Shift click <Item Link> here",
       get     = false,
       set     = function(info, v) addon:Rem(v) end,
       },
       divider4 = {
       order   = 48,
       type    = "description",
       name    = "",
       },
       listjunklist = {
       order   = 49,
       type    = "execute",
       name    = "Junklist",
       desc    = "List Items in Junklist.",
       func    = function() addon:listjunk() end,
       },
       clearjunklist = {
       order   = 50,
       type    = "execute",
       name    = "Clear",
       desc    = "Removes Junk Sell List Items.",
       func    = function() addon:Clearjunklist() end,
       },
       divider5 = {
       order   = 51,
       type    = "description",
       name    = "",
       },
       divider6 = {
       order   = 52,
       type    = "description",
       name    = "",
       },
       note2   = {
       order   = -1,
       type    = "description",
       name    = "Click Reload UI after making configuration changes.",
       },
       reload_ui = {
       order   = -1,
       type    = "execute",
       name    = "ReLoad UI",
       desc    = "Reloads UI Interface.",
       func    = function() ReloadUI() end,
       },
     }
    }
   }
  }
 end
end
---------------------------------------------------------------------------------------------------------------------------------
--[[ END DTweaks InGame Options MENUs ]]-- 
---------------------------------------------------------------------------------------------------------------------------------
